;
;	TLOG
;

		.186
		.MODEL	TINY

		INCLUDE	STDDEFS.INC
		INCLUDE	TLOGVER.INC



TLOGVect	EQU	71h

PROGTYPE	EQU <"BMS">


$TLOG		MACRO
		INT	TLOGVect
		ENDM


DGROUP		GROUP	NOTRESIDE,NOTRESIDE_DATA,NOTRESIDE_BSS


;-------------------------------
;R[hF풓
;-------------------------------

		.CODE

		PUBLIC	TLOG_Remove,TLOG_Restore,TLOG_RestoreStart
		PUBLIC	TLOG_Clear
		PUBLIC	Store
		EXTRN	TLOG_Entry:FAR
		EXTRN	LOG_Init:NEAR
		EXTRN	Mem_Init:NEAR,Mem_Select:NEAR,Mem_Activate:NEAR
		EXTRN	Mem_Inactivate:NEAR,Mem_Segment:NEAR,Mem_Remove:NEAR
		EXTRN	_atoi:NEAR	;풓Ŏgp

		ASSUME	CS:DGROUP

		ORG	100h

Start:
		JMP	RealStart

TsrName		DB "%",PROGNAME,0		;풓p
						;ύXȂ
		DB VERSION_STR,0







;
;@́FDS
;	 ;DS:SI=p[^e[u
;	 AX=gpł郁C̃ZOgAhX
;@óFCF=0
;	   BX=CgpʁipOtj
;	 CF=1
;	   AL=G[ԍ
;@jF*
Init	PROC

		CALL	Mem_Init
		JC	@f
;		JC	#Err
		MOV	FreeL,AX
		MOV	FreeH,DX
		MOV	LogTotalSizeL,AX
		MOV	LogTotalSizeH,DX

		CLR	AX
		MOV	NextOfs,AX
		MOV	NextPage,AX

		PUSH	BX
		CALL	LOG_Init
		POP	BX

		CLC
		RET

@@:
;#Err:
		STC
		RET

Init	ENDP



;
;@́FDS
;@óFAL=0
;@jF
TLOG_Remove	PROC


		;荞݃xN^
		PUSH	DS
		LDS	DX,OldVect
		mov	ax,2500h+TLOGVect
		int	21h
		POP	DS

		CALL	Mem_Remove

		RET

TLOG_Remove	ENDP



;
;@́FDS
;	 ES:DI=i[f[^̃AhX
;	 CX=i[f[^̃oCg
;@óF
;@jF*
;@ӁFēs
Store	PROC

		CALL	Mem_Activate

		PUSH	CX

					;CX=i[f[^̎coCg

		_REPEAT
			OR	CX,CX
			_BREAK Z

			MOV	BX,LogPageSize
			SUB	BX,NextOfs	;BX=݃y[W̎coCg

			_IF Z
				;coCg 0 ͂肦Ȃ
				;LogPageSize=64K,NextOfs=0
				MOV	BX,CX
			_ELSE
				CMP	CX,BX
				_IF BE
					;CX<=BX
					MOV	BX,CX
				_ENDIF
			_ENDIF
					       ;BX=݃y[WɊi[oCg
			SUB	CX,BX

			PUSH	CX

			MOV	CX,BX	       ;CX=݃y[WɊi[oCg
			MOV	AX,NextPage
			CALL	Mem_Select	;y[WI
			CALL	Mem_Segment	;ZOg擾

			PUSH	AX

		;NextOfs/Page XV
			MOV	BX,NextOfs
			MOV	DX,BX
			ADD	BX,CX
			CMP	BX,LogPageSize
			_IF E			;LogPageSize=0 -> 
						;	BX=0 or BX>LogPageSize
						;̑ ->
						;    BX>LogPageSizeł肦Ȃ
				CLR	BX
				MOV	AX,NextPage
				INC	AX
				CMP	AX,LogPages
				_IF E
					CLR	AX
				_ENDIF
				MOV	NextPage,AX
			_ENDIF
			MOV	NextOfs,BX

		;CXoCgRs[
			MOV	SI,DI
			MOV	AX,ES

			POP	ES
			PUSH	DS

			MOV	DS,AX
			MOV	DI,DX


			CLD
			SHR	CX,1
			REP	MOVSW
			_IF C
				MOVSB
			_ENDIF

			MOV	AX,DS
			MOV	ES,AX
			MOV	DI,SI

			POP	DS

			POP	CX
		_WHILE

		POP	CX

		CALL	Mem_Inactivate

	;󂫃oCgXV
		MOV	AX,FreeL
		MOV	DX,FreeH
		SUB	AX,CX
		SBB	DX,0
		_IF C
			CLR	AX
			MOV	DX,AX
		_ENDIF
		MOV	FreeL,AX
		MOV	FreeH,DX

		RET

Store	ENDP




;
;@́FDS
;@óF
;	 RestoreOfs/Page
;@jF*
;@ӁF荞݃[`̌Ăяos
TLOG_RestoreStart	LABEL	PROC
RestoreStart	PROC

		PUSHF
		CLI
IF 0
		MOV	AX,LogPageSize
		MOV	DX,LogPages
		OR	AX,AX
		_IFN Z
			;LogPageSize>0(64K łȂꍇ)
			MUL	DX
		_ENDIF
ELSE
							;2001/12/22 
		MOV	AX,LogTotalSizeL
		MOV	DX,LogTotalSizeH
ENDIF
		SUB	AX,FreeL
		SBB	DX,FreeH
		MOV	RestoreBytesL,AX
		MOV	RestoreBytesH,DX

		MOV	AX,FreeL
		MOV	DX,FreeH
		MOV	SI,LogPageSize		;SI=LogPageSize
		MOV	CX,SI
		OR	CX,CX
		_IF Z
			XCHG	AX,DX
		_ELSE
			DIV	CX
		_ENDIF

		MOV	CX,NextOfs
		MOV	BX,NextPage
		
		ADD	CX,DX			;DX<LogPageSize
		JC	@L1
;		JC	#L1

		OR	SI,SI
		JZ	@L2			;LogPageSize=64K CX<64K
;		JZ	#L2			;LogPageSize=64K CX<64K
		CMP	CX,SI
		JB	@L2
;		JB	#L2
		SUB	CX,SI
@L1:
;#L1:
		INC	AX
@L2:
;#L2:
		MOV	RestoreOfs,CX

		ADD	BX,AX
		CMP	BX,LogPages
		_IF AE
			SUB	BX,LogPages
		_ENDIF
		MOV	RestorePage,BX

		POPF
		RET

RestoreStart	ENDP


;
;@́FES:DI=i[AhX
;	 CX=i[oCg
;@óFAX=i[oCg
;@jF*
;@ӁF荞݃[`̌Ăяos
TLOG_Restore	LABEL	PROC
Restore	PROC

		CALL	Mem_Activate


		CMP	RestoreBytesH,0
		_IF Z
			CMP	RestoreBytesL,CX
			_IF B
				MOV	CX,RestoreBytesL
			_ENDIF
		_ENDIF

		PUSH	CX

					;CX=of[^̎coCg

		_REPEAT
			OR	CX,CX
			_BREAK Z

			MOV	BX,LogPageSize
			SUB	BX,RestoreOfs	;BX=݃y[W̎coCg

			_IF Z
				;coCg 0 ͂肦Ȃ
				;LogPageSize=64K,RestoreOfs=0
				MOV	BX,CX
			_ELSE
				CMP	CX,BX
				_IF BE
					;CX<=BX
					MOV	BX,CX
				_ENDIF
			_ENDIF
					       ;BX=݃y[Wo
					       ;   oCg
			SUB	CX,BX
			SUB	RestoreBytesL,BX
			SBB	RestoreBytesH,0

			PUSH	CX

			MOV	CX,BX	       ;CX=݃y[Wo
						;  oCg
			MOV	AX,RestorePage
			CALL	Mem_Select	;y[WI
			CALL	Mem_Segment	;ZOg擾

			PUSH	AX

		;RestoreOfs/Page XV
			MOV	BX,RestoreOfs
			MOV	DX,BX
			ADD	BX,CX
			CMP	BX,LogPageSize
			_IF E			;LogPageSize=0 -> 
						;	BX=0 or BX>LogPageSize
						;̑ ->
						;    BX>LogPageSizeł肦Ȃ
				CLR	BX
				MOV	AX,RestorePage
				INC	AX
				CMP	AX,LogPages
				_IF E
					CLR	AX
				_ENDIF
				MOV	RestorePage,AX
			_ENDIF
			MOV	RestoreOfs,BX

		;CXoCgRs[
			MOV	AX,DS

			POP	DS
			PUSH	AX	;ƂDS

			MOV	SI,DX

			CLD
			SHR	CX,1
			REP	MOVSW
			_IF C
				MOVSB
			_ENDIF

			POP	DS

			POP	CX
		_WHILE


		CALL	Mem_Inactivate

		POP	AX

		RET

Restore	ENDP


IF 0
Ă݂͂ǖmF 2001/12/22 

;OwoCg
;@́FCX=oCg
;	 DS
;@óF
;@jFAX,DX
TLOG_Discard	PROC

		PUSHF
		CLI


		MOV	AX,FreeL
		MOV	DX,FreeH
		ADD	AX,CX
		ADC	DX,0

		CMP	DX,LogTotalSizeH
		JB	#Good
		JA	#Over
		CMP	AX,LogTotalSizeL
		JBE	#Good
		;JA	#Over
#Over:
		MOV	AX,LogTotalSizeL
		MOV	DX,LogTotalSizeH
#Good:
		MOV	FreeL,AX
		MOV	FreeH,DX

		POPF
		RET

TLOG_Discard	ENDP

ENDIF

;O
;@́FDS
;@óF
;@jFAX
TLOG_Clear	PROC

		PUSHF
		CLI

		MOV	AX,LogTotalSizeL
		MOV	FreeL,AX
		MOV	AX,LogTotalSizeH
		MOV	FreeH,AX

		POPF

		RET

TLOG_Clear	ENDP



;-------------------------------
;f[^F풓
;-------------------------------


		.DATA

		PUBLIC	LogPageSize,LogPages
		EXTRN	BinaryLimit:WORD


LogPageSize	DW ?		;_y[WTCYioCgj0=64K
LogPages	DW ?		;_y[W

LogTotalSizeL	DW ?		;LogPageSize * LogPages ̉
LogTotalSizeH	DW ?		;LogPageSize * LogPages ̏

FreeL		DW ?		;󂫃TCYioCgj
FreeH		DW ?

NextOfs		DW ?		;̃f[^܂̃|C^
NextPage	DW ?

RestoreOfs	DW ?		;̎of[^̃|C^
RestorePage	DW ?

RestoreBytesL	DW ?		;ooCg
RestoreBytesH	DW ?

		.DATA?

PageLeft	DW ?

OldVect		DD ?




;-------------------------------
;R[hF풓
;-------------------------------


NOTRESIDE	SEGMENT	PUBLIC	'NOTRESIDE'

TSREnd		LABEL	BYTE


		PUBLIC	AtoI,Print
		EXTRN	Add_CommandLine:NEAR,Add_PrintErr:NEAR
		EXTRN	VSPrintF:NEAR

		ASSUME	CS:DGROUP





StartUp		PROC

RealSTART::
		MOVSEG	DS,CS

		CALL	MakeArg

		;풓`FbN
		CALL	TsrChk
		_IF Z
			;풓Ă
			MOV	TSRSeg,ES
		_ENDIF

		;XCb`
		MOV	BX,OFFSET _ARGV
		MOV	CX,_ARGC
		CLD
		_REPEAT
			DEC	CX
			_BREAK Z
			INC	BX
			INC	BX
			
			MOV	SI,[BX]
			LODSB
			
			CMP	AL,'-'
			JZ	@f
;			JZ	#Switch
			CMP	AL,'/'
			JZ	@f
;			JZ	#Switch

			DEC	SI
			MOV	FileName,SI

			_CONT

@@:
;#Switch:
			LODSB
			OR	AL,20h
			CMP	AL,'r'
			JZ	@Sw_R
;			JZ	#Sw_R

			CMP	AL,'s'
			JZ	@Sw_S
;			JZ	#Sw_S

			CMP	AL,'m'
			JZ	@Sw_M
;			JZ	#Sw_M

			CMP	AL,'p'
			JZ	@Sw_P
;			JZ	#Sw_P

			CMP	AL,'c'
			JZ	@Sw_C
;			JZ	#Sw_C


					;AL=XCb`ij
					;DS:SI=XCb`̎̃AhX
					;DS:[BX]=݂̃p[^̃AhX
					;CX=̂p[^
					;   (ݏ̕܂)
			CALL	Add_CommandLine
					;ZF=1..XCb`Ƃď
					;   0..Ȃ
			_CONT Z

			CALL	Usage
			MOV	AL,0FFh
			JMP	@Exit
;			JMP	#Exit


@Sw_R:			MOV	SW_R,1
;#Sw_R:			MOV	SW_R,1
			_CONT

@Sw_S:			MOV	SW_S,1
;#Sw_S:			MOV	SW_S,1
			_CONT

@Sw_M:			MOV	SW_M,1
;#Sw_M:			MOV	SW_M,1
			_CONT

@Sw_P:
;#Sw_P:
			;PutBinary ̍őoCg
			CALL	AtoI
			MOV	BinaryLimit,AX
			_CONT

@Sw_C:			MOV	SW_C,1
;#Sw_C:			MOV	SW_C,1
			_CONT

		_WHILE


		CMP	Sw_R,0
		JNZ	@Remove
;		JNZ	#Remove

		CMP	Sw_S,0
		JNZ	@Save
;		JNZ	#Save

		CMP	Sw_M,0
		JNZ	@Memo
;		JNZ	#Memo

		CMP	Sw_C,0
		JNZ	@Clear
;		JNZ	#Clear

		;풓

		MOV	AX,TSRSeg
		MOV	ES,AX
		OR	AX,AX
		_IFN Z
			;풓Ă
			CALL	Usage
			MOV	AL,0FFh
			JMP	@Exit
;			JMP	#Exit
		_ELSE
			;풓ĂȂ
			CALL	Reside
		_ENDIF
		MOV	AL,0FFh
		JMP	@Exit
;		JMP	#Exit

@Remove:
;#Remove:
		CALL	ErrExitIfNotResided
		MOV	ES,AX
		JMP	Remove

@Save:
;#Save:
		CALL	ErrExitIfNotResided
		CALL	Save
		JMP	@Exit
;		JMP	#Exit

@Memo:
;#Memo:
		CALL	ErrExitIfNotResided
		CALL	Memo
		JMP	@Exit
;		JMP	#Exit

@Clear:
;#Clear:
		CALL	ErrExitIfNotResided
		CALL	Clear
		JMP	@Exit
;		JMP	#Exit

@Exit:
;#Exit:
		MOV	AH,4Ch
		INT	21H		;vZXI

PrintErrExit::
		CALL	Print
		MOV	AL,0FFh
		JMP	@Exit
;		JMP	#Exit

StartUp		ENDP



;
;@́F
;@óFAX=풓ZOg
;@jF
ErrExitIfNotResided	PROC

		MOV	AX,TSRSeg
		OR	AX,AX
		JZ	@f
;		JZ	#Err

		RET
@@:
;#Err:
		;풓ĂȂ
		MOV	SI,OFFSET NOTRESIDED
		JMP	PrintErrExit

ErrExitIfNotResided	ENDP






;풓
;@́FDS
;@óF
;@jFALL
Reside	PROC


		;I[i[̓o^
		MOV	CL,Owner[0]
		MOV	CH,0
		ADD	CX,2
		CALL	_OWNER


		;ʌ
		MOV	AX,OFFSET TSREnd
		ADD	AX,15
		SHR	AX,4

		PUSH	AX

		MOV	DX,CS
		ADD	AX,DX		;풓R[hEf[^̎̃ZOg
		CALL	Init
					;BX=KvCTCYipOt

		_IF C
					;AL=G[ԍ
			CALL	Add_PrintErr
			POP	AX
			RET
		_ENDIF

		POP	AX

		ADD	AX,BX
		JC	@f
;		JC	#NOMEMERR

		MOV	TSRPara,AX
		MOV	DX,CS
		ADD	AX,DX			;AX=풓A풓̈̒
						;ZOg
		JC	@f
;		JC	#NOMEMERR

		CMP	AX,DS:[0002h]		;vZXŏIZOg+1
		_IF A
@@:
;#NOMEMERR:
			;s
			MOV	SI,OFFSET NOMEM
			CALL	Print
			RET
		_ENDIF


		;荞݃xN^
		mov	ax,3500h+TLOGVect
		int	21h
					;ES:BX
		MOV	WORD PTR OldVect[0],BX
		MOV	WORD PTR OldVect[2],ES
		MOV	dx,OFFSET TLOG_Entry
		mov	ax,2500h+TLOGVect
		int	21h

		;bZ[W
		MOV	SI,OFFSET M_Title
		CALL	Print
		MOV	SI,OFFSET JYOUTYU
		CALL	Print

;IF 0
		;ϐ̈̊J
		;CMP	Machine,0
		;_IF Z
			;98̂
			MOV	AX,DS:[002Ch]
			MOV	ES,AX
			MOV	AH,49h
			INT	21h
		;_ENDIF
;ENDIF

		;풓I
		MOV	DX,TSRPara
		MOV	AX,3100H
		INT	21H

Reside	ENDP



;
;@́F
;@óF
;@jF
Usage	PROC

		MOV	SI,OFFSET M_Title
		CALL	Print
		MOV	SI,OFFSET M_Copyright
		CALL	Print
		MOV	SI,OFFSET M_Usage
		CALL	Print
		MOV	SI,OFFSET M_Options
		CALL	Print
		MOV	SI,OFFSET M_AddOptions
		CALL	Print

		MOV	SI,OFFSET M_Info1
		MOV	BX,OFFSET BinaryLimit
		MOVSEG	ES,DS
		MOV	DI,OFFSET PrintFBuf
		CALL	VSPrintF
		MOV	SI,OFFSET PrintFBuf
		CALL	Print

		RET

Usage	ENDP



;풓
;@́FDS
;        ES=풓ZOg
;@óFAȂ
;@jF
Remove	PROC

		PUSH	0Fh
		$TLOG
		ADD	SP,2

		;J
		MOV	AH,49H
		INT	21H		;풓GAJ

		MOV	SI,OFFSET KAIJYO
		CALL	Print

		;I
		MOV	AX,4C00H
		INT	21H

Remove	ENDP


;-------------------------------
;R[hF풓[eBeB[
;-------------------------------

;
;@́FDS
;	 FileName
;@óFAL=vZXIR[h
;@jF*
SAVEBUFSIZE	EQU	4096

Save	PROC

		MOV	DX,FileName
		OR	DX,DX
		JZ	@f
;		JZ	#Err

		MOV	AX,3D01h
		INT	21h
		_IF C
			CMP	AX,2
			JNE	@f
;			JNE	#Err

			;t@CȂ
			MOV	CX,BIT5
			MOV	AH,3Ch
			INT	21h
			JC	@f
;			JC	#Err
			MOV	BX,AX
		_ELSE
			;t@C̍ŌɃ|C^ړ
			MOV	BX,AX
			MOV	AX,4202h
			CLR	CX
			MOV	DX,CX
			INT	21h
		_ENDIF


		PUSH	0Dh
		$TLOG
		ADD	SP,2

		_REPEAT
			MOV	CX,SAVEBUFSIZE
			MOV	AX,DS
			MOV	ES,AX
			MOV	DI,OFFSET SaveBuf

			PUSH	0Eh
			$TLOG
			ADD	SP,2
			OR	AX,AX
			_BREAK Z

			MOV	DX,OFFSET SaveBuf
			MOV	CX,AX
			MOV	AH,40h
			INT	21h
		_WHILE

		MOV	AH,3Eh
		INT	21h

		;O
		PUSH	0Ch
		$TLOG
		ADD	SP,2

		MOV	SI,OFFSET HOZON
		CALL	Print

		MOV	AL,0
		RET

@@:
;#Err:
		CMP	AX,10h
		_IF AE
			CLR	AX
		_ENDIF
		MOV	BX,AX
		ADD	BX,BX
		MOV	SI,DosErrTable[BX]
		CALL	Print

		MOV	AL,0FFh
		RET

Save	ENDP


;
;@́F
;@óF
;@jF
Memo	PROC

		MOV	AX,MemoStr
		OR	AX,AX
		JZ	@f
;		JZ	#Err

		PUSH	CS
		PUSH	AX
		PUSH	04h
		$TLOG
		ADD	SP,6

@@:;#Err:
		RET

Memo	ENDP


;
;@́F
;@óF
;@jF
Clear	PROC

		PUSH	0Ch
		$TLOG
		ADD	SP,2

		MOV	SI,OFFSET SYOUKYO
		CALL	Print

		MOV	AL,0
		RET

Clear	ENDP


;-------------------------------
;R[hF풓
;-------------------------------

;
;@́FDS
;@óFZF=1..풓Ă 0..풓ĂȂ
;	 ES=풓ZOg
;@jF
TsrChk	PROC

		mov	ax,3500h+TLOGVect
		int	21h
					;ES:BX
		MOV	DI,OFFSET TsrName
		MOV	SI,DI

		CLD
		_REPEAT
			LODSB
			CMP	AL,0
			_BREAK E

			CMP	ES:[DI],AL
			_BREAK NE
			INC	DI
		_WHILE

		RET
TsrChk	ENDP

;\
;@́FDS:SI=̃AhX
;@jFAX,BX,CX,DX
Print	PROC


		PUSH	DI
		PUSH	ES
	
		MOVSEG	ES,DS
		MOV	DI,SI
		MOV	AL,0
		MOV	CX,1000h
		CLD
		REPNZ	SCASB
		NEG	CX
		ADD	CX,1000h-1
		MOV	DX,SI
		MOV	BX,2			;WG[o
		MOV	AH,40h
		INT	21h
	
		POP	ES
		POP	DI

	RET

Print	ENDP


;AtoI
;@́FDS:SI=̃AhX
;@óFAX=l
;@jFES
AtoI	PROC

		PUSH	BX
		PUSH	CX
		PUSH	DX

		PUSH	SI
		CALL	_atoi
		ADD	SP,2

		POP	DX
		POP	CX
		POP	BX
		RET

AtoI	ENDP



;R}hC`qfuC`qfb쐬
;@́FDS=DGROUP=PSP
;@óFDS:_ARGC,DS:_ARGV
;@jFAX,SI,DI
;@⑫F_ARGC>=1 łAARGV[0] ͖gp

ARGCMAX		EQU	16

MakeArg		PROC

		MOV	SI,0080H
		MOV	DI,OFFSET DGROUP:_ARGV[2]
		MOV	_ARGC,1

		_REPEAT
			_REPEAT
				INC	SI
				MOV	AL,BYTE PTR [SI]
				CMP	AL,' '
			_WHILE E

			CMP	AL,0DH
			_BREAK E

			MOV	WORD PTR [DI],SI
			INC	DI
			INC	DI
			INC	_ARGC

			_REPEAT
				INC	SI
				MOV	AL,BYTE PTR [SI]
				CMP	AL,0DH
				_BREAK E
				CMP	AL,' '
			_WHILE NE

			MOV	BYTE PTR [SI],0
			CMP	AL,0DH
			_BREAK E
			CMP	_ARGC,ARGCMAX
		_WHILE NE

		RET

MakeArg		ENDP





		INCLUDE	_OWNER.PRC		; By  Mipro. 1993

NOTRESIDE	ENDS


;-------------------------------
;f[^F풓
;-------------------------------

NOTRESIDE_DATA	SEGMENT	PUBLIC	'NOTRESIDE'


		EXTRN	M_Title:Byte,M_Usage:Byte,M_AddOptions:Byte
		EXTRN	Owner:Byte

;TITLE	DB "TLOG",PROGTYPE," v",VERSION_STR,"  for PC-88VA/PC-98x1",CR,LF,0
M_Copyright	DB "(c) XMaZ Project 1998,2001",CR,LF,CR,LF,0
;M_Usage	DB "F TLOG",PROGTYPE," [IvV]",CR,LF
M_Options	LABEL	BYTE
	DB "       IvV",CR,LF
	DB "         /R            (Remove) 풓",CR,LF
	DB "         /S t@C (Save) Õt@Cւ̕ۑ",CR,LF
	DB "         /M      (Memo) OɕL^",CR,LF
	DB "         /Pn           (Packet) pPbgL^̍őL^oCg",CR,LF
	DB "         /C            (Clear) O",CR,LF
	DB 0

M_Info1	LABEL	BYTE
	DB CR,LF
	DB "         /P ͏풓Ƃ̂ݗLBl %dB",CR,LF
	DB 0


JYOUTYU	DB "풓܂B",CR,LF,0
KAIJYO	DB "풓܂B",CR,LF,0
NOTRESIDED DB "풓Ă܂B",CR,LF,0
HOZON	DB "ۑ܂B",CR,LF,0
SYOUKYO	DB "܂B",CR,LF,0

;MCBERR	DB "AP[Vj󂳂Ă܂B",BEL,CR,LF,0
;KAIJERR DB "荞݃xN^̂srqɎgpĂď풓ł܂B"
;	DB BEL,CR,LF,0
;DEFERR	DB "`t@C %d sڂɌ肪܂B",BEL,CR,LF,0
;NODEFERR DB "`t@CI[vł܂B",BEL,CR,LF,0
NOMEM	DB "܂B",BEL,CR,LF,0
LOGMEMERR	DB "OL^pmۂł܂B",BEL,CR,LF,0

BADPATHERR	DB "ȃpXłB",BEL,CR,LF,0
BADDRIVEERR	DB "ȃhCułB",BEL,CR,LF,0
OPENERR		DB "t@CJ܂Bt@CnhsĂ܂B",BEL,CR,LF,0
ACCESSERR	DB "ANZXł܂B",BEL,CR,LF,0
UNKNOWNERR	DB "t@CANZXɕsȃG[܂B",BEL,CR,LF,0

DosErrTable	DW UNKNOWNERR,UNKNOWNERR,UNKNOWNERR,BADPATHERR
		DW OPENERR,ACCESSERR,UNKNOWNERR,UNKNOWNERR
		DW UNKNOWNERR,UNKNOWNERR,UNKNOWNERR,UNKNOWNERR
		DW UNKNOWNERR,UNKNOWNERR,UNKNOWNERR,BADDRIVEERR


TSRPara		DW ?				;풓TCYipOtj
TSRSeg		DW 0				;풓ZOg

SW_R		DB 0		;풓
SW_S		DB 0		;Z[u
SW_M		DB 0		;
SW_C		DB 0		;NA

MemoStr		LABEL	WORD
FileName	DW 0

NOTRESIDE_DATA	ENDS



NOTRESIDE_BSS	SEGMENT	PUBLIC	'NOTRESIDE'


_ARGC	DW ?
_ARGV	DW ARGCMAX DUP (?)

PrintFBuf	DB 256 DUP (?)

SaveBuf		DB SAVEBUFSIZE DUP (?)


NOTRESIDE_BSS	ENDS


		END	Start


;1998/10/ 2 
;1998/10/ 3 
;1998/10/ 4 
;1998/10/ 5 

;2001/12/ 9 /PXCb`
;2001/12/10 /SɃt@CI[vG[炻̎|\B
;2001/12/22 TLOG_Clear, LogTotalSizeL/H, /CXCb`, ϐ̈̉
;2001/12/23 Usage\CA/Sŕۑ烍ONAB
