;
;	TEEN API
;	for 80186
;
;	$Header$
;

		OPTION OLDSTRUCTS

		INCLUDE	STDDEFS.INC		; (c) ChaN 1989

		.186
		.MODEL	TINY

;TEENVect	EQU	70h
TEENIFIdent	EQU	"%TEENAPI",0

;USELOGFLUSH	EQU	ON			;ĂяoILOG_Flush
						;s
V020		EQU	ON


SAVEREGS	STRUC
S_ES		DW ?
S_DI		DW ?
S_SI		DW ?
S_BP		DW ?
S_SP		DW ?
S_BX		DW ?
S_DX		DW ?
S_CX		DW ?
S_AX		DW ?
SAVEREGS	ENDS



DGROUP		GROUP	INITTEXT

		.CODE


		PUBLIC	TEENIF_Init,TEENIF_Release

		EXTRN	TEEN_Remove:Near,TEEN_Check:Near,TEEN_Version:Near,TEEN_tmem_disp:Near
		EXTRN	TEEN_MachType:Near, TEEN_tmem_info:Near
		EXTRN	LM_Open:Near,LM_Close:Near,LM_State:Near
		EXTRN	DIALUP_Open:Near,DIALUP_Close:Near
		EXTRN	TCP_ActiveOpen:Near,TCP_PassiveOpen:Near,TCP_Shutdown:Near
		EXTRN	TCP_Close:Near,TCP_Send:Near,TCP_Recv:Near,TCP_Accept:Near,TCP_State:Near
		EXTRN	TCP_DownState:Near,TCP_GetAddr:Near,TCP_Peek:Near
		EXTRN	UDP_Open:Near,UDP_Close:Near,UDP_State:Near,UDP_Send:Near,UDP_Recv:Near
		EXTRN	UDP_SendTo:Near,UDP_RecvFrom:Near,UDP_GetMyAddr:Near,UDP_GetPeerAddr:Near
		EXTRN	IP_RTGET:Near,ICMP_Send:Near,ICMP_Recv:Near
		EXTRN	LOG_Switch:Near
		EXTRN	DNS_GetIPAddress:Near
		EXTRN	INDICATE:Near,INDICATE_INT:Near,INDICATE_STR:Near,INDICATE_SW:Near
		EXTRN	INET_ToIPv4Addr:Near,INET_IPv4AddrToIPAddr:Near
		EXTRN	INET_ToIPAddr:Near,INET_ToStr:Near
		EXTRN	INET_IsWildcard:Near
		EXTRN	ARP_GetEntry:Near
		EXTRN	TIMER_MSecClock:Near

		EXTRN	TEEN_SelectUMB:Near,TEEN_RelUMB:Near


IFDEF USELOGFLUSH
		EXTRN	LOG_Flush:Near
ENDIF


;tbN
;@́FDS
;@óF
;@jFAX,DX
TEENIF_Init	PROC

		MOV	AL,TEENVect
		MOV	UseVectNo,AL
		MOV	AH,35h
		INT	21h
		MOV	WORD PTR OldVect[0],BX
		MOV	WORD PTR OldVect[2],ES

		PUSH	DS
		MOVSEG	DS,CS
		MOV	DX,OFFSET TEEN_Entry
		MOV	AL,UseVectNo
		MOV	AH,25h
		INT	21h
		POP	DS

		RET

TEENIF_Init	ENDP


;tbN
;@́FDS
;@óF
;@jFAX,DX
TEENIF_Release	PROC

		MOV	AL,UseVectNo
		PUSH	DS
		LDS	DX,OldVect
		MOV	AH,25h
		INT	21h
		POP	DS

		RET

TEENIF_Release	ENDP


;
;@́FAH=t@NVԍ
;	 AL,BX,CX,DX,SI,DI,ES
;@óF
;@jFAX,BX,CX,DX,SI,DI,BP,ES
		DB	TEENIFIdent		;荞ݔԍp
TEEN_Entry	PROC	FAR

		PUSH	DS

		MOVSEG	DS,CS


		;ēh~
		CMP	InService,OFF
		JNZ	@Busy

		MOV	InService,ON

		;X^bNύX
		MOV	SaveSS,SS
		MOV	SaveSP,SP
		MOV	DataSeg,DS
		CLI	
		MOV	SS,DataSeg
		MOV	SP,TEENIFStack
		STI



		PUSHA
		PUSH	ES

		MOV	BP,BX		;SAVE BX

		CALL	TEEN_SelectUMB
		MOV	Port152,BX

		MOV	BL,AH
		SHR	BL,2
		AND	BL,0FCh
		MOV	BH,0
		ADD	BX,OFFSET FuncGroup

		AND	AH,0Fh
		CMP	AH,[BX][2]
		_IF AE
			CALL	NoFunc
			JMP	RET_CAL
		_ELSE
			SHL	AH,2
			MOV	BX,[BX][0]
			ADD	BL,AH
			ADC	BH,0

			PUSH	WORD PTR [BX][2]
			PUSH	WORD PTR [BX][0]
			MOV	BX,BP		;LOAD BX
			RETN	;NEAR CALL
		_ENDIF

RET_TCP_AL::
IFDEF V020
		MOV	AH,AL
		AND	AL,07Fh
		MOV	BP,SP
		MOV	BYTE PTR [BP].S_AX,AL
		SHL	AH,1		;AL̍ŏʃrbgCF
		JMP	RET_CF
ENDIF

RET_AL_Z::
		OR	AL,AL
		STC
		JNZ	RET_CAL
RET_AL::
		CLC
RET_CAL::
		MOV	BP,SP
		MOV	BYTE PTR [BP].S_AX,AL
		JMP	RET_CF

RET_TCP_AX::
IFDEF V020
		MOV	BP,SP
		MOV	[BP].S_AX,AX
		SHL	DH,1			;DH̍ŏʃrbgCF
		JMP	RET_CF
ENDIF

RET_AX:
		CLC
RET_CAX::
		MOV	BP,SP
		MOV	[BP].S_AX,AX
		JMP	RET_CF

RET_DXAX::
		CLC
RET_CDXAX::
		MOV	BP,SP
		MOV	[BP].S_AX,AX
		MOV	[BP].S_DX,DX
		JMP	RET_CF

RET_NON::
		CLC
RET_CF:

IFDEF USELOGFLUSH
		PUSHF
		CALL	LOG_Flush
		POPF
ENDIF

		PUSHF
		MOV	BX,Port152
		CALL	TEEN_RelUMB
		POPF

		POP	ES
		POPA

		;X^bNύX
		CLI
		MOV	SS,SaveSS
		MOV	SP,SaveSP
		STI

		MOV	InService,OFF
@Exit:
		PUSH	BP
		MOV	BP,SP
					;BP+0:BP,+2:DS,+4:OFS,+6:SEG,+8:FLAG
		_IF C
			OR	BYTE PTR [BP][8],1
		_ELSE
			AND	BYTE PTR [BP][8],0FEh
		_ENDIF
		POP	BP
		POP	DS
		IRET

@Busy:
		MOV	AL,002h
		STC
		JMP	@Exit

TEEN_Entry	ENDP





;t@NVԍُ
;@́FDS
;@óFAL,CF
;@jF
NoFunc	PROC

	MOV	AL,001h
	STC
	RET

NoFunc	ENDP




		.DATA

		PUBLIC	TEENIFStack

		; e[u	t@NV
FuncGroup	DW FuncTEEN  	,16	;0
		DW FuncDIALUP	,6	;1
		DW FuncINET	,5	;2
		DW FuncDNS	,1	;3
		DW FuncTCP	,13	;4
		DW FuncUDP	,12	;5
		DW FuncIP	,6	;6
		DW 0,0			;7
		DW FuncLM	,4	;8
		DW FuncIND	,5	;9
		DW FuncDev	,1	;A
		DW 0,0			;B
		DW 0,0			;C
		DW 0,0			;D
		DW 0,0			;E
		DW 0,0			;F

FuncTEEN	DW TEEN_Check,	RET_CAL		;0
		DW TEEN_Version,RET_CAX		;1
		DW TEEN_MachType,RET_CAX	;2
		DW TIMER_MSecClock,	RET_DXAX	;3
		DW NoFunc,	RET_CAL		;4
		DW NoFunc,	RET_CAL		;5
		DW NoFunc,	RET_CAL		;6
		DW NoFunc,	RET_CAL		;7
		DW NoFunc,	RET_CAL		;8
		DW NoFunc,	RET_CAL		;9
		DW NoFunc,	RET_CAL		;A
		DW TEEN_tmem_info,RET_CAL	;B
		DW LOG_Switch,	RET_NON		;C	;LOG_Type
		DW TEEN_tmem_disp,RET_CAL	;D
		DW NoFunc,	RET_CAL		;E
		DW TEEN_Remove, RET_CAL		;F

FuncDIALUP	DW NoFunc,	RET_CAL		;0
		DW DIALUP_Open,	RET_AL_Z	;1
		DW DIALUP_Close,RET_AL_Z	;2
		DW LM_Open,	RET_NON		;3
		DW LM_Close,	RET_NON		;4
		DW LM_State,	RET_AL		;5

FuncINET	DW INET_ToIPAddr,	RET_CAL		;0
		DW INET_ToStr,		RET_CAL		;1
		DW INET_ToIPv4Addr,	RET_CDXAX	;2
		DW INET_IPv4AddrToIPAddr,RET_NON	;3
		DW INET_IsWildcard,	RET_AL		;4

FuncDNS		DW DNS_GetIPAddress,RET_CDXAX	;0

FuncLM		DW LM_Open,	RET_NON		;0
		DW LM_Close,	RET_NON		;1
		DW LM_State,	RET_AL		;2
		DW NoFunc,	RET_CAL		;3

FuncTCP		DW TCP_ActiveOpen	,RET_TCP_AL	;0
		DW TCP_PassiveOpen	,RET_TCP_AL	;1
		DW TCP_Accept		,RET_TCP_AL	;2
		DW TCP_Shutdown		,RET_TCP_AL	;3
		DW TCP_Close		,RET_TCP_AL	;4
		DW TCP_Send		,RET_TCP_AX	;5
		DW TCP_Recv		,RET_TCP_AX	;6
		DW TCP_State		,RET_TCP_AL	;7
		DW TCP_DownState	,RET_TCP_AL	;8
		DW TCP_GetAddr		,RET_TCP_AL	;9
		DW NoFunc		,RET_CAL	;A
		DW NoFunc		,RET_CAL	;B
		DW TCP_Peek		,RET_TCP_AX	;C

FuncUDP		DW UDP_Open		,RET_TCP_AL	;0
		DW UDP_Close		,RET_TCP_AL	;1
		DW UDP_State		,RET_TCP_AL	;2
		DW NoFunc		,RET_CAL	;3
		DW UDP_Send		,RET_TCP_AX	;4
		DW UDP_Recv		,RET_TCP_AX	;5
		DW UDP_SendTo		,RET_TCP_AX	;6
		DW UDP_RecvFrom		,RET_TCP_AX	;7
		DW NoFunc		,RET_CAL	;8
		DW NoFunc		,RET_CAL	;9
		DW UDP_GetMyAddr	,RET_CAX	;A
		DW UDP_GetPeerAddr	,RET_CAX	;B

FuncIP		DW IP_RTGET		,RET_AL_Z	;0
		DW NoFunc		,RET_CAL	;1 (rtset)
		DW NoFunc		,RET_CAL	;2
		DW NoFunc		,RET_CAL	;3
		DW ICMP_Send		,RET_AL_Z	;4
		DW ICMP_Recv		,RET_AL_Z	;5

FuncIND		DW INDICATE_SW	,RET_NON	;0
		DW NoFunc	,RET_CAL	;1
		DW INDICATE	,RET_NON	;2
		DW INDICATE_INT	,RET_NON	;3
		DW INDICATE_STR	,RET_NON	;4

FuncDev		DW ARP_GetEntry	,RET_CAL	;0


TEENIFStack	DW OFFSET DGROUP:EndStack

InService	DB OFF
		DB ?

		.DATA?

OldVect		DD ?
SaveSS		DW ?
SaveSP		DW ?
DataSeg		DW ?
UseVectNo	DB ?			;API Ɏgp荞ݔԍ
		DB ?
Port152		DW ?

STACKLEN	EQU 1024

_STACK		SEGMENT	PUBLIC	'STACK'
		DB	STACKLEN DUP (?)
EndStack	LABEL	BYTE
_STACK		ENDS



;-------------------------------
;풓
;-------------------------------


INITTEXT	SEGMENT	PUBLIC	'STACK'

		EXTRN	TEENVect:BYTE

INITTEXT	ENDS

		end
