/*
	DNS NCAg
	for i80x86

	$Header: dnsclt.cv  1.1  99/09/04 10:18:34  Exp $
*/

/*
ȉ̂Rw̃T[rXȂ

  _dns_query Ȃ
    DNSւ̖₢킹sȂB
    ₢킹镶͂zXgƂĉ߁BIPAhX񂩂ǂ
    ʂȂBDNST[o֖₢킹

  ns_queryipaddr
    zXgIPAhX֕ϊBzXg̓zXgAIPAhXA
    IPAhX\̂ł悢B

  dns_getipaddress
    ns_* ƓlAIPAhX炩ɂȂ邩A^CAEg܂ő҂B

*/



#pragma inline

#include <mem.h>	/* setmem */
#include <dos.h>	/* enable,disable,MK_FP,FP_OFF */


#include <inet.h>
#include <tmem.h>
#include <timer.h>
#include <udpapi.h>
#include <log.h>

#include "dnsclt.h"


/*******************************
@@@@@@}N
*******************************/
#define ON 1
#define OFF 0
#define NULL 0


#define HANDLESMAX 5
#define UDPRBUFSIZE 640		/* UDPMpobt@ */
#define DNSRBUFSIZE UDPRBUFSIZE	/* DNSpPbgMpobt@ */

#if 0
#define THISPORT 4999		/* ̎gp|[g */
#endif

#define DNSPORT 53


#define DNSTYPE_A 1
#define DNSTYPE_MX 15
#define DNSTYPE_CNAME 5


/*
DNSpPbg̊etB[h̒ioCgj
*/
#define TYPELEN 2
#define CLASSLEN 2
#define TTLLEN 4
#define LENLEN 2


/*
ݐ
*/
#define CLI()	disable()
#define STI()	enable()

/*******************************
@@@@@@@^
*******************************/
typedef struct {
	IWORD id;
	struct {
				/* PoCg */
		WORD rd:1;	/* vFċA₢킹 */
		WORD tc:1;	/* FTCYɂ薖؂̂ */
		WORD aa:1;	/* Fo^T[o */
		WORD opcode:4;	/* vF0.ʏ 1.t */
		WORD qr:1;	/* 0.₢킹 1. */

				/* QoCg */
		WORD rcode:4;	/* R[h */
		WORD zero:3;	/* 0 */
		WORD ra:1;	/* FċA₢킹T|[g */
	} ctrl;			/* 16bit */
	IWORD queryrecords;	/* ₢킹R[h */
	IWORD responserecords;	/* R[h */
	IWORD registerrecords;	/* o^@փR[h */
	IWORD additionalrecords;/* ǉR[h */
} dnsheadertype;


typedef enum {S_FREE,S_WAIT,S_HAVEANSWER,S_HAVEIP,S_FAIL} statetype;


typedef struct {
	BYTE handle;
	BYTE id;		/* ₢킹bZ[WIDʃoCg */
				/* ʂ handle ɓ */

	dnsheadertype far *query;	/* MpPbg */
	uint querylen;			/* ̃oCg */
	dnsheadertype far *answer;	/* MpPbg */
	IDWORD ip;			/* 擾 IP AhX */
	int timer;			/* ^CAEg^C} */

	void (far *callback)();
	int callbackid;		/* R[obNĂяoɓnID */

	statetype state;	/*  */
	uchar retry;		/* đJE^iZj */
} handletabletype;


/*******************************
@@@@@@@ϐ
*******************************/

struct {
	char *str_pri_server;	/* T[oAhX() */
	char *str_sec_server;	/* T[oAhX() */
} DNS_SReg={"",""};

struct {
	BYTE timeout;		/* 100 ^CAEg܂ł̎ԁibj*/
	BYTE retry;		/* 101 ő呗M(>0) */
} DNS_BReg={3,3};

#define sreg DNS_SReg
#define breg DNS_BReg

#if 0
static dnsheadertype far *answer[HANDLESMAX];	/* enhɑ΂ԓ
						   DNS pPbg */
static char handleuse[HANDLESMAX]={0};	/* nhgĂON */
					/* 0ŏ邾낤(^^; */
#else
static handletabletype handlet[HANDLESMAX];
#endif

static char timeoutflag;		/* dns_getipaddress */

static char udphandle=-1;		/* udp nh */
static BYTE udprbuf[UDPRBUFSIZE];	/* udp Mobt@ */


/*******************************
@@@@@vg^Cv
*******************************/

void far dns_receive(void);
static void reltimer(handletabletype *ht);


/*******************************
@@@@@@R[h
*******************************/

/*------------------------------
  
------------------------------*/

/*

@ӁFudpapi_init 肠ƂɌĂԂ
*/

void dns_init(void)
{
	UDPPRM udpprm;
	int i;

	setmem(&udpprm,sizeof udpprm, 0);
	udpprm.rbuf=udprbuf;
	udpprm.rbufsize=UDPRBUFSIZE;
	udpprm.host=sreg.str_pri_server;
				/* {́AIPł邱ƂmFKv*/
	udpprm.peerport=DNSPORT;

	/*log_printf("%x %x %x",udpprm.rbank,udpprm.sbank,udpprm.rbufsize);*/

#if 0
	udpprm.callback=dns_receive;
#else
	{
		uint tmp;
asm		mov	tmp,offset dns_receive;
		udpprm.callback=MK_FP(_CS,tmp);
	}
#endif
	if ( (udphandle=udp_open(&udpprm)) & 0x80 ) {
		/* nhmێs */
		udphandle=-1;
	}
#if !defined(NOLOG)
	log_printf("DNS : UDPnh %d",udphandle);
#endif


	for (i=0; i<HANDLESMAX; i++) {
		handlet[i].handle=i;
		handlet[i].state=S_FREE;
	}
}



/*------------------------------
  nhǗ
------------------------------*/

/*
󂫃nh擾
  óFchar		-1 󂫂Ȃ
  			̑ nh
*/
static char gethandle(void)
{
	int i;
	handletabletype *ht;

	for (i=0, ht=handlet; i<HANDLESMAX && ht->state!=S_FREE; i++, ht++);
	if (i>=HANDLESMAX) return -1;
	else {
		ht->state=S_WAIT;
		ht->query=NULL;
		ht->answer=NULL;
		ht->timer=-1;
		ht->callback=NULL;
		return i;
	}
}

/*
nhJ
*/
static void relhandle(char handle)
{
	void far *p;
	handletabletype *ht;

	ht=&handlet[handle];
	/*CLI();*/
	/*handlet[handle].answer=NULL;*/
	ht->state=S_FREE;
	/*STI();*/
	if ( (p=(void far *)(ht->answer))!=NULL ) tmem_free(p);
	if ( (p=(void far *)(ht->query))!=NULL ) tmem_free(p);
	reltimer(ht);
}


/*
nhe[u̗vfԂ
*/
static handletabletype *handle2t(BYTE handle)
{
	return (handle>=HANDLESMAX) ? 0 : 
	       (handlet[handle].state==S_FREE) ? 0 : &handlet[handle];
}


/*
^C}nh(ns)nh𓾂
  óFchar		-1 YȂ
  			̑ nh
*/
static char timer2handle(int timer)
{
	int i;
	
	for (i=0; i<HANDLESMAX; i++) {
		if (handlet[i].state!=S_FREE && handlet[i].timer==timer) {
			return i;
		}
	}
	return -1;
}


/*
^C}̉
*/
static void reltimer(handletabletype *ht)
{
	timer_remove(ht->timer);
	ht->timer=-1;
}

/*------------------------------
  f[^쐬E
------------------------------*/

/*
DNSp .\L̖Oϊ
  ́Fchar *buf	ϊo͐(\0͕tȂ)(name̒2)
	char *name	O
@óFint		0..  -1..OsK
*/
static int encodename(char far *buf, char const far *name)
{
	char far *dot;
	uchar i=0;

	dot=buf;
	buf++;
	while (*name!='\0') {
		if (*name=='.') {
			if (i==0 || i>63) return -1;
			*dot=i;
			dot=buf;
			i=0;
		}
		else {
			*buf=*name;
			i++;
		}
		buf++;
		name++;
	}
	if (i==0 || i>63) return -1;
	*dot=i;
	*buf=0;

	return 0;
}

#if 0
/*
Ǒ
@́Fchar far *name			O
  óFint				0..OƂĕsK
  					1..OƂēK
  ⑫Fȉ̂PȏɊYꍇAOƂĕsK
        (encodenameɗ^ƂADNSpPbgƂĕsKȂ̂𐶐Ă܂)
        E'.'ł͂܂
        E'.'ł
        E'.'QȏA
	Ename 0łB
*/
static int checkname(char const far *name)
{
	char wasdot=OFF;
	char c;

	c=*(name++);
	if (c=='.' || c=='\0') return OFF;
	while ((c=*(name++))!='\0') {
		if (c=='.') {
			if (wasdot) return OFF;
			else wasdot=ON;
		}
		else {
			wasdot=OFF;
		}
	}

	return (wasdot) ? OFF : ON;
}
#endif


/*
OtB[h̎̃AhXԂ
@́FBYTE far *namefield		OtB[h
@óFBYTE far *			OtB[ĥ
*/
static BYTE far *skipnamefield(BYTE far *namefield)
{
	BYTE len;

	for (;;) {
		len=*(namefield++);
		if (len>=192) {
			/* kꂽ */
			namefield++;
			break;
		}
		else if (len>0) {
			namefield+=len;
		}
		else {
			/* Ō */
			break;
		}
	}

	return namefield;
}


/*
̃R[hԂ
@́FBYTE far *record		R[h
	int kind			1..₢킹R[h 0..ȊO
@óFBYTE far *			̃R[h
*/
static BYTE far *nextrecord(BYTE far *record, int kind)
{
	record=skipnamefield(record)+TYPELEN+CLASSLEN;
	if (kind==0) {
		record+=TTLLEN;
		record+=inet_word(*(IWORD far *)record)+LENLEN;
	}
	return record;
}



/*
̒
*/
static int fstrlen(char const far *str)
{
	int i;

	for (i=0; *str!='\0'; str++,i++);

	return i;
}


/*
bZ[W̍ŏ̉R[h IP AhXo
@óFchar		G[R[h
			0 
			ENS_NOHOST
*/
static char getip(dnsheadertype far *hed, IDWORD *ip)
{
	BYTE far *record;
	BYTE far *field;
	uint i,e;
	char ret;

	if (hed->ctrl.rcode==0 && hed->responserecords>0) {
		record=(BYTE far *)hed+sizeof(dnsheadertype);
		e=inet_word(hed->queryrecords);
		for(i=0; i<e; i++) record=nextrecord(record,1);
						/* ₢킹R[h΂*/
		do {
			field=skipnamefield(record);	/* ^CvtB[h */
			record=nextrecord(record,0);	/* ̃R[h */
		} while (inet_word(*(IWORD far *)field)!=DNSTYPE_A);

		*ip=*(IDWORD far *)(field+TYPELEN+CLASSLEN+TTLLEN+LENLEN);
							/* \[XtB[h*/
		/*log_put("DNS : ₢킹");*/
		ret=0;
	}
	else {
	    	log_put("DNS : ԓɃG[orԓR[hȂ");
		log_printf("DNS : hed=%Fp,rcode=%d, rrecords=%d",hed,hed->ctrl.rcode,hed->responserecords);
		ret=ENS_NOHOST;
	}

	return ret;
}


/*------------------------------
  MACxg
------------------------------*/

/*
DNSpPbgMʒmFUDPĂ΂
*/

void far dns_receive(void)
{
#define PACKETLEN DNSRBUFSIZE

	dnsheadertype far *hed;
	handletabletype *ht;
	WORD id;
	BYTE handle,idh;


#if !defined(NOLOG)
	log_put("DNS : M");
#endif
	if ( (hed=tmem_alloc((PACKETLEN+15)/16)) == NULL) {
		log_put("DNS : 擾s");
		udp_recv(udphandle,NULL,0);	/* ̂Ă */
		return;				/* 1999/ 9/ 4 */
	}

/*	log_putbinary(udppacket,160);*/

	udp_recv(udphandle,(BYTE far *)hed,PACKETLEN);

	id=inet_word(hed->id);
	handle = id&0xff;
	idh = id>>8;

	ht=handle2t(handle);
	if (ht==NULL || ht->state!=S_WAIT || ht->id!=idh) {
#if !defined(NOLOG)
		log_printf("DNS : IDُ:%x",id);
#endif
		tmem_free(hed);
		return;
	}

	reltimer(ht);
	ht->answer=hed;
	ht->state=S_HAVEANSWER;
	if ((long)ht->callback) ht->callback(handle,ht->callbackid);

	return;
}


/*
₢킹pPbgM
*/
static void dns_sendquery(handletabletype *ht)
{
#if !defined(NOLOG)
	log_printf("DNS : M %u byte",ht->querylen);
#endif
	udp_send(udphandle,(BYTE far *)(ht->query),ht->querylen);
}

/*
static void getipaddress_timeout(int handle)
{
	timeoutflag=ON;
}
*/

/*
₢킹^CAEgFTIMER Ă΂
*/
static void dns_timeout(int timer)
{
	BYTE handle;
	handletabletype *ht;

#if !defined(NOLOG)
	log_put("DNS : ^CAEg");
#endif

	handle=timer2handle(timer);
	if (handle<0) {
		/* ΉnhȂF^C}Ȃ
		   \ */
#if !defined(NOLOG)
		log_put("DNS : Y^C}nhȂ");
#endif
		return;
	}

	ht=handle2t(handle);
	if (ht==NULL) {
		/* ?? */
		return;
	}

	if ( (-- ht->retry) == 0) {
		/* s */
		ht->state=S_FAIL;
		reltimer(ht);
#if !defined(NOLOG)
		log_put("DNS : đ~");
#endif
	}
	else {
		dns_sendquery(ht);
	}
}

/*------------------------------
  API DNS ₢킹
------------------------------*/

/*
₢킹
@́FO
	Iy[VR[hэċA₢킹tO
		bit3-bit0 0..ʏ 1..t
		DNSQUERY_RECURSIVE
	ċA₢킹vtO
	₢킹^Cv

@óFchar		<0x80..nh
			>=0x80..G[
			  0x80+7 Enhs
			  0x80+8 OsK
*/
BYTE _dns_query(const char far *name, WORD type, WORD opcode, void (far *callback)(), int callbackid)
{
	dnsheadertype far *hed;
	handletabletype *ht;
	BYTE far *record;
	BYTE handle;
	int namelen,packetlen;
#if 0
	IDWORD server;
#endif

	if ( (handle=gethandle()) & 0x80) {
		return 0x80+ENS_NORESOURCE; 
		/* nhs */
	}

	ht=&handlet[handle];
	ht->callback=callback;
	ht->callbackid=callbackid;

	namelen=fstrlen(name);
	packetlen=sizeof(dnsheadertype) + namelen + 2+TYPELEN+CLASSLEN;
					/* 2: Oϊɑ镶 */
	hed=tmem_alloc((packetlen+15)/16);
	if (hed==NULL) {
		/* mۂł */
		relhandle(handle);
		return 0x80+ENS_NORESOURCE;
	}

	hed->id=inet_word( (++ht->id << 8) | handle );
	*(WORD far *)(&(hed->ctrl))=0;
	/* hed->ctrl.qr=0; */
	hed->ctrl.opcode=opcode & 0x0f; /*(flag & DNSQUERY_REVER) ? 1 : 0;*/
	hed->ctrl.rd=(opcode & DNSQUERY_RECURSIVE) ? 1 : 0;
	/* hed->ctrl.zero=0; */
	hed->queryrecords=inet_word(1);
	hed->responserecords=hed->registerrecords=hed->additionalrecords=0;
	record=(BYTE far *)hed+ sizeof(dnsheadertype);
	if (encodename(record,name)<0) {
		/* OsK */
		tmem_free(hed);
		relhandle(handle);
		return 0x80+ENS_BADNAME;
	}

	record+=namelen+2;
	((IWORD far *)record)[0]=inet_word(type);
	((IWORD far *)record)[1]=inet_word(1);
#if 0
	/* T[oI */
	{
		static char nbuf[17];

		strncpy(nbuf,sreg.str_pri_server,16);
		server=inet_aton(nbuf);
	}

	/* hed  packetlen oCgM */
	udp_send((BYTE far *)hed,packetlen,server);
	log_printf("DNS : %s ɑM",inet_ntoa(server));
#else

	ht->query=hed;
	ht->querylen=packetlen;
	dns_sendquery(ht);

	if (breg.retry==0) breg.retry=1;
	ht->retry=breg.retry;
	ht->timer=timer_set(dns_timeout,(uint)breg.timeout*100);

#endif


	return handle;
}


/*
₢킹I
*/
char _dns_end(BYTE handle)
{
	return (handle2t(handle)) ? relhandle(handle),0 : ENS_BADHANDLE;
}


/*
擾
@óFdnsheadertype far *	 DNSpPbg
				NULL:Ȃ
*/
dnsheadertype far *_dns_getresponse(BYTE handle)
{
#if 0
	dnsheadertype far *ans;

	/*log_printf("DNS : getresponse %d=%Fp",handle,answer[handle]);*/
	CLI();
	ans=answer[handle];
	STI();
	return ans;
#else
	return (handlet[handle].state==S_HAVEANSWER) ?
		handlet[handle].answer :
		0;

#endif
}



/*------------------------------
  API O->IPAhXϊ
------------------------------*/

/*
₢킹FIPAhX
  ́Fconst char far *name	zXgAIPAhXAIPAhX\
@óFBYTE			<0x80 nh
				̑ G[
*/
BYTE ns_queryipaddr(const char far *name, void (far *callback)(), int callbackid)
{
	uint i;
	BYTE handle;
	IDWORD ipv4addr;

	if ( inet_toipv4addr(name,&ipv4addr) == 0 ) {
		/* IPAhX܂IPAhX\̂ł */

		handletabletype *ht;

		if ( (handle=gethandle()) & 0x80) {
			/* nhs */
			return 0x80+ENS_NORESOURCE; 
		}
		ht=&handlet[handle];
		ht->ip=ipv4addr;
		ht->state=S_HAVEIP;

		return handle;
	}

	handle=_dns_query(name,DNSTYPE_A,DNSQUERY_RECURSIVE,callback,callbackid);

	return handle;
}


/*
₢킹I
@óFchar			G[R[h
*/
char ns_end(BYTE handle)
{
#if 0
	return (handle2t(handle)) ? relhandle(handle),0 : ENS_BADHANDLE;
#else
	return _dns_end(handle);
#endif
}


/*
擾FIPAhX擾
@óFchar		0..I
			ENS_NOHOST..zXg݂Ȃ
			ENS_NORESPONSE..܂ԓȂ
			ENS_BADHANDLE
			ENS_TIMEOUT
*/
char ns_getipaddr(BYTE handle, IDWORD *ip)
{
	dnsheadertype far *hed;
	handletabletype *ht;
	char ret;

	if ( (ht=handle2t(handle)) == NULL ) return ENS_BADHANDLE;

	if ( ht->state==S_HAVEIP ) {
		*ip=ht->ip;
		ret=0;
	}
	else if ( ht->state==S_FAIL ) {
		ret=ENS_TIMEOUT;
	}
	else {
	/* @@ S_WAITǂ̂ł́HH 2001/ 7/30 */

		if ( (hed=_dns_getresponse(handle)) == NULL ) {
			return ENS_NORESPONSE;
		}
		ret=getip(hed,ip);
	}

	/*relhandle(handle);*/
	return ret;
}


/*------------------------------
   API O->IPAhXϊ
------------------------------*/

/*
OIPAhX擾
@́Fchar far *name			zXg܂IPAhX
	IDWORD *ipaddress		IPAhXi[ϐւ̃|C^
@óFchar				0..I ̑..G[
	IDWORD *ipaddress		IPAhX
@ӁFēs
  ⑫FG[ԍ
			 6.zXgȂ
			 7.G[(nhs)
			 8.OsK
			 9.^CAEg
*/

char dns_getipaddress(const char far *name, IDWORD *ipaddress)
{
	char handle;
	int timerhandle;
	char ret,tof;

	handle=ns_queryipaddr(name,NULL,0);
	if (handle & 0x80) {
#if !defined(NOLOG)
		log_printf("DNS : getipaddress: queryipaddr err=%d",handle & 0x7f);
#endif
		return handle & 0x7f;
	}

	while ( (ret=ns_getipaddr(handle,ipaddress)) == ENS_NORESPONSE );

	ns_end(handle);
	return ret;
}



/*
1997/12/ 7 
1997/12/ 9 
1997/12/10 
1997/12/22 
1998/ 2/24 dns_getipaddress:IPAhX͂Ƃĉ\
	   ԓ𓾂̂IPAhX0Ԃ̂C
	   (answer[handle]̓ǂ݂Ɋ荞݂answerւ
	   ̂H)
1998/ 3/ 7 dns_getipaddress,dns_query:G[Ԃ

1998/11/ 3 udp api 쐬ɔ udp gpύXB
	   handletabletype 쐬ɍ킹ĕύXB
	   ns_queryipaddr,ns_getipaddr 
	   98/2/24ɏCoO͍ĔȂH
1998/11/22 dns_getipaddress IPAhX͂Ƃė^ƃ^CAEg
	   Ԃ̂C

1999/ 7/ 6 UDPRBUFSIZE  300  640 ɕύX
	   l[T[o[̉pPbg 300oCg𒴂邱Ƃ邽
1999/ 8/18 _udp_query: hed  tmem_freeĂȂ̂C
1999/ 9/ 4 _dns_receive: tmem擾s͑return(擾sɃj
	   󂵂Ă̂CB)
	   PACKETLENύX
2000/ 1/18 ns_queryipaddr name  IPAhX\(IPADDR)B
2000/ 9/14 _dns_query: dnsheadertype.ctrl  0 ɏĂgpB

2001/ 7/30 _dns_query: ₢킹đ
	   dns_getipaddress: Lɍ킹ύX
2001/ 9/30 gethandle: ht->timer,query 悤ɂ
	   RgAEgĂTu[`폜
	   dns_end: _dns_end ɉ
	   ns_end: _dns_end ĂяoAɕύX
	   dns_getipaddress: dns_end ̑ ns_end ĂяoB

oOFZJ_T[o𗘗pĂȂ
      ;dns_getipaddress T[o琳ԓAāA炩Ƀ^CAEg
      ;OȂ̂ 0 ԂƂB
      dns_getipaddress: zXg"0.0.0.0"w肷ƃG[ɂȂB
      ns_quetyipaddr ɗ^ IP AhX̎AR[obNĂ΂Ȃ

*/

