.xlist
.sall
;********************************
;*				*
;*	cnrW`wb_	*
;*				*
;*	(C)ChaN, 1989		*
;*				*
;********************************

;------------------------------------------------------------------------------
;	ASCII control code definition

	NUL	equ	0	; null character
	CR	equ	0dh	; carriage return
	LF	equ	0ah	; line feed
	FF	equ	0ch	; form feed
	BS	equ	08h	; back space
	BEL	equ	07h	; bell
	TAB	equ	09h	; holizontal tabulation
	EOF	equ	1ah	; end of file
;	ESC	equ	1bh	; escape
	DEL	equ	7fh	; delete


;------------------------------------------------------------------------------
;	Bit operation

	BIT0	equ	0000000000000001b
	BIT1	equ	0000000000000010b
	BIT2	equ	0000000000000100b
	BIT3	equ	0000000000001000b
	BIT4	equ	0000000000010000b
	BIT5	equ	0000000000100000b
	BIT6	equ	0000000001000000b
	BIT7	equ	0000000010000000b
	BIT8	equ	0000000100000000b
	BIT9	equ	0000001000000000b
	BIT10	equ	0000010000000000b
	BIT11	equ	0000100000000000b
	BIT12	equ	0001000000000000b
	BIT13	equ	0010000000000000b
	BIT14	equ	0100000000000000b
	BIT15	equ	1000000000000000b


;------------------------------------------------------------------------------
;	Flag op.

	ON	equ	-1
	OFF	equ	0

;------------------------------------------------------------------------------
;	Stack op.

;	push	equ	pushm		; OPTASM
;	pop	equ	popm		; OPTASM

;------------------------------------------------------------------------------
;	Type

;	bptr	equ	byte ptr
;	wptr	equ	word ptr
;	dwptr	equ	dword ptr
;	ofs	equ	offset
;	len	equ	length

;------------------------------------------------------------------------------
;	double word op.

;@32	macro	par1,par2
;	db	66h
;    IFNB <par2>
;	par1,8000h
;	org	$-2
;	dd	par2
;    ELSE
;	par1
;    ENDIF
;	endm


;**********************************************
;	W}N
;**********************************************

$DOS	macro	func,par		;; cnrt@NV
    IFNB <par>
	mov	ax,(func SHL 8)+(par AND 0ffh)
    ELSE
	mov	ah,func
    ENDIF
	int	21h
	endm

$EMM	macro	func,par		;; dllt@NV
    IFNB <par>
	mov	ax,(func shl 8)+(par and 0ffh)
    ELSE
	mov	ah,func
    ENDIF
	int	67h
	endm


movseg	macro	dst,src		;; ZOg]
	push	src
	pop	dst
	endm

;sds	macro	dst,src		;; far ߲]
;	mov	wptr dst[0],src
;	mov	wptr dst[2],ds
;	endm

;ses	macro	dst,src
;	mov	wptr dst[0],src
;	mov	wptr dst[2],es
;	endm

;inp	macro	reg,port	;; |[go
;	mov	dx,port
;	in	reg,dx
;	endm

;outp	macro	port,reg	;; |[g
;	mov	dx,port
;	out	dx,reg
;	endm

;inb	macro	dest,port	;; input byte
;    IF	port ge 100h
;	inp	al,port
;    ELSE
;	in	al,port
;    ENDIF
;	mov	dest,al
;	endm

;outb	macro	port,src	;; output byte
;	mov	al,src
;    IF	port ge 100h
;	outp	port,al
;    ELSE
;	out	port,al
;    ENDIF
;	endm

;inw	macro	dest,port	;; input word
;    IF	port ge 100h
;	inp	ax,port
;    ELSE
;	in	ax,port
;    ENDIF
;	mov	dest,ax
;	endm

;outw	macro	port,src	;; output word
;	mov	ax,src
;    IF	port ge 100h
;	outp	port,ax
;    ELSE
;	out	port,ax
;    ENDIF
;	endm


set	macro	dest,bt		;; ޯľ or ׸޾
    IFNB <bt>
	or	dest,bt
    ELSE
	mov	dest,ON
    ENDIF
	endm
	
res	macro	dest,bt		;; ޯؾ or ׸ؾ
    IFNB <bt>
	and	dest,not bt
    ELSE
	mov	dest,OFF
    ENDIF
	endm

cpl	macro	dest,bt		;; ޯĺ or ׸޺
    IFNB <bt>
	xor	dest,bt
    ELSE
	not	dest
    ENDIF
	endm

;tst	macro	dest		;; value 
;	cmp	dest,0
;	endm

clr	macro	reg		;; ڼ޽ر
	xor	reg,reg
	endm

;setpb	macro	port,dat	;; I/O port logical op.
;    IF port ge 100h
;	inp	al,port
;	set	al,dat
;	out	dx,al
;    ELSE
;	in	al,port
;	set	al,dat
;	out	port,al
;    ENDIF
;	endm

;respb	macro	port,dat	;; I/O port logical op.
;    IF port ge 100h
;	inp	al,port
;	res	al,dat
;	out	dx,al
;    ELSE
;	in	al,port
;	res	al,dat
;	out	port,al
;    ENDIF
;	endm

;tstpb	macro	port,dat	;; I/O port bit test
;    IF port ge 100h
;	inp	al,port
;    ELSE
;	in	al,port
;    ENDIF
;	test	al,dat
;	endm


;$ret	equ	ret			;; OPTASM
;ret	equ	_ret			;; OPTASM
;retn	equ	_retn			;; OPTASM

;_ret	macro	cc,dst,src		;; ^  OPTASM
;	local	l
;  IFNB	<cc>
;   IFNB  <dst>
;	cmp	dst,src
;   ENDIF
;	jn&cc	l
;	$ret
;l:
;  ELSE
;	$ret
;  ENDIF
;	endm

;_retn	macro	cc,dst,src		;;   OPTASM
;	local	l
;  IFNB  <dst>
;	cmp	dst,src
;  ENDIF
;	j&cc	l
;	$ret
;l:
;	endm



;************************************************
;	\}N
;************************************************

	irpc	n,0123456789		;; Ƃ肠WKw܂ŃlXg
	$LP&n	= 0
	endm

	$LNUM	= 0
	$NEST	= 0


_if	macro	cc,dst,src		;; ubNJn
	$enter	%$NEST,%($NEST+1)	;; cc ubNs
	$LNUM	= $LNUM+1
  IFNB <src>
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	n,cc,%$NEST,%$LNUM
	endm

_ifn	macro	cc,dst,src		;; ubNJn
	$enter	%$NEST,%($NEST+1)	;; cc sȂubNs
	$LNUM	= $LNUM+1
  IFNB <src>
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	<>,cc,%$NEST,%$LNUM
	endm

_skip	macro	cc,dst,src		;; ubNXLbvi_ifn Ɠj
	$enter	%$NEST,%($NEST+1)	;; cc 𗪂ƖXLbv
	$LNUM	= $LNUM+1
  IFNB <src>
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	<>,cc,%$NEST,%$LNUM
	endm

@if	macro	cc,inst			;; PƖ߁iPj
	local	l1
	jn&cc	l1
	inst
l1:
	endm

@ifn	macro	cc,inst			;; PƖ߁iQj
	local	l1
	j&cc	l1
	inst
l1:
	endm

_else	macro				;; t̏ꍇs
	$jmp	%$NEST,%($LNUM+1)
	$label	%$NEST,%$LNUM
	$LNUM	= $LNUM+1
	endm

_endif	macro				;; ubN̏I[
	$label	%$NEST,%$LNUM
	$leave	%$NEST,%($NEST-1)
	endm

__endif	macro				;; ubN̏I[iQAj
	_endif
	_endif
	endm

___endif macro				;; ubN̏I[iRAj
	_endif
	_endif
	_endif
	endm

_repeat	macro	count			;; REPEAT [v̊Jni擪j
	$enter	%$NEST,%($NEST+1)	;; count ݒ肷 cx ɒl۰
  IFNB	<count>
	mov	cx,count
  ENDIF
	$LNUM	= $LNUM+1
	$label	%$NEST,%$LNUM
	endm

_break	macro	cc,dst,src		;; cc ꍇA
  IFNB <src>				;; REPEAT [v𔲂
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	<>,cc,%$NEST,%($LNUM+1)
	endm

_cont	macro	cc,dst,src		;; cc ꍇA
  IFNB <src>				;; REPEAT [v̐擪ĊJ
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	<>,cc,%$NEST,%$LNUM
	endm

_while	macro	cc,dst,src		;; REPEAT [v̏I[
  IFNB <src>				;; cc ԁA擪Ƃ̊ԂJԂ
	cmp	dst,src			;; cc 𗪂Əɐ
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	<>,cc,%$NEST,%$LNUM
	$LNUM	= $LNUM+1
	$label	%$NEST,%$LNUM
	$leave	%$NEST,%($NEST-1)
	endm


_loop	macro	cc,dst,src		;; REPEAT [v̏I[
  IFNB <src>				;; 擪Ƃ̊Ԃ loop s
	cmp	dst,src			;; cc ȗ
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$loop	cc,%$NEST,%$LNUM
	$LNUM	= $LNUM+1
	$label	%$NEST,%$LNUM
	$leave	%$NEST,%($NEST-1)
	endm




$enter	macro	a,b			;; lXgEC
  IF	$NEST ge 8			;; 
	%out	* Nesting Over! *
  ENDIF
	$LP&a	= $LNUM
	$LNUM	= $LP&b
	$NEST	= $NEST+1
	endm

$leave	macro	a,b			;; lXgEAEg
  IF	$NEST  eq 0
	%out	* Nesting Over! *
  ENDIF
	$LP&a	= $LNUM
	$LNUM	= $LP&b
	$NEST	= $NEST-1
	endm

$label	macro	l,m			;; x̐
$L&l&_&m:
	endm

$jcc	macro	n,cc,l,m		;; Wv̐
  IFNB	<cc>
	j&n&cc	$L&l&_&m
  ELSE
	jmp	$L&l&_&m
  ENDIF
	endm

$jmp	macro	l,m			;; Wv̐
	jmp	$L&l&_&m
	endm

$loop	macro	cc,l,m			;; LOOP߂̐
	loop&cc	$L&l&_&m
	endm

$term	macro				;; ŏIlXeBOE`FbN
    IF	$NEST ne 0
	%out	* Block Macro Open Nest *
    ENDIF
	endm


;*****************
;** END OF FILE **
;*****************
.list
