/*
 * Copyright (c) 1997  XMaZ Project.
 *
 *  isoternet Protocol Library / Common Routines / isoternet checksum
 *
 *  $Id: in_cksum.c,v 1.2 1997/09/23 16:52:39 nakamura Exp nakamura $
 */

#include <ttypes.h>

WORD in_cksum(BYTE FAR *data, int len)
{
    long sum = 0;

    while( len > 1 )  {
       sum += * (WORD FAR *) data;
       data += 2;
       len -= 2;
    }
    if( len > 0 ) {
       sum += * (BYTE FAR *) data;
    }
    while (sum >> 16) {
        sum = (sum & 0xffff) + (sum >> 16);
    }
    return ~sum;
}
