;
;	TLOG API
;	for 80186
;
;	$Header$
;

		OPTION OLDSTRUCTS

		INCLUDE	STDDEFS.INC		; (c) ChaN 1989

		.186
		.MODEL	TINY

TLOGIFIdent	EQU "%TLOGAPI",0

FUNCTIONS	EQU 16


SAVEREGS	STRUC
S_ES		DW ?
S_DS		DW ?
S_DI		DW ?
S_SI		DW ?
S_BP		DW ?
S_SP		DW ?
S_BX		DW ?
S_DX		DW ?
S_CX		DW ?
S_AX		DW ?
SAVEREGS	ENDS






		.CODE


		PUBLIC	TLOG_Entry
		EXTRN	TLOG_Remove:Word,TLOG_Restore:Word,TLOG_RestoreStart:Word
		EXTRN	TLOG_Put:Word,TLOG_PutChar:Word,TLOG_PrintF:Word,TLOG_PutBinary:Word
		EXTRN	TLOG_PutMulti:Word,TLOG_VPrintF:Word
		EXTRN	TLOG_Clear:Word


;
;@́F
;	 PUSH p[^,p[^...
;	 PUSH t@NVԍ
;	 INT	XX
;	 ܂
;	 AL,CX,DX,SI,DI,ES
;@óF
;@jFAX,BX,CX,DX,SI,DI,BP,ES
		DB	TLOGIFIdent		;荞ݔԍp
TLOG_Entry	PROC	FAR

		;ēh~
		;CMP	CS:InService,OFF
		;JNZ	#Busy

		;MOV	CS:InService,ON


		PUSHA
		PUSH	DS
		PUSH	ES

		MOVSEG	DS,CS

		MOV	BP,SP
		ADD	BP,TYPE SAVEREGS + 6	;6=CS,IP,FLAG
						;[BP][0] t@NVԍ
						;[BP][-2]..p[^

		TEST	WORD PTR [BP-2],BIT9	;荞݋tO
		_IFN Z
			STI
		_ENDIF

		MOV	AH,[BP][0]
		CMP	AH,FUNCTIONS
		_IF AE
			CALL	NoFunc
			JMP	RET_NON
		_ELSE
			SHL	AH,2
			MOV	BX,OFFSET Func
			ADD	BL,AH
			ADC	BH,0

			PUSH	WORD PTR [BX][2]
			PUSH	WORD PTR [BX][0]
			RETN	;NEAR CALL	;DS,CS,SS,SPȊOj
		_ENDIF


RET_AL_Z:
		OR	AL,AL
		STC
		JNZ	RET_CAL
RET_AL:
		CLC
RET_CAL::
		MOV	BP,SP
		MOV	BYTE PTR [BP].S_AX,AL
		JMP	RET_CF

RET_AX::
		CLC
RET_CAX:
		MOV	BP,SP
		MOV	[BP].S_AX,AX
		JMP	RET_CF

RET_CDXAX:
		MOV	BP,SP
		MOV	[BP].S_AX,AX
		MOV	[BP].S_DX,DX
		JMP	RET_CF

RET_NON::
		CLC
RET_CF:


		POP	ES
		POP	DS
		POPA


		;MOV	CS:InService,OFF

@Exit:
;#Exit:
		PUSH	BP
		MOV	BP,SP
					;BP+0:BP,+2:OFS,+4:SEG,+6:FLAG
		_IF C
			OR	BYTE PTR [BP][6],1
		_ELSE
			AND	BYTE PTR [BP][6],0FEh
		_ENDIF
		POP	BP
		IRET

@Busy:
;#Busy:
		JMP	@Exit
;		JMP	#Exit

TLOG_Entry	ENDP





;t@NVԍُ
;@́FDS
;@óFAL,CF
;@jF
NoFunc	PROC

	MOV	AL,001h
	STC
	RET

NoFunc	ENDP




		.DATA


Func		DW NoFunc,	RET_NON		;0	;CHECK
		DW NoFunc,	RET_NON		;1	;VERSION
		DW NoFunc,	RET_NON		;2	;MACTYPE
		DW TLOG_PutChar,RET_NON		;3
		DW TLOG_Put,	RET_NON		;4
		DW TLOG_PrintF,	RET_NON		;5
		DW TLOG_VPrintF,RET_NON		;6
		DW TLOG_PutBinary,RET_NON	;7
		DW TLOG_PutMulti,RET_NON	;8
		DW NoFunc,	RET_NON		;9
		DW NoFunc,	RET_NON		;A
		DW NoFunc,	RET_NON		;B
		DW TLOG_Clear,	RET_NON		;C
		DW TLOG_RestoreStart,	RET_NON	;D
		DW TLOG_Restore,RET_AX		;E
		DW TLOG_Remove, RET_CAL		;F

;1998/10/ 4
;2001/12/22 TLOG_Clear

		end
