;
;	TCP.C - ASM C^tF[X
;	for i8086,Turbo-C
;
;	$Header$
;


		INCLUDE	STDDEFS.INC

		.186
		.MODEL	SMALL



		.CODE

		PUBLIC	TCP_ActiveOpen,TCP_PassiveOpen,TCP_Shutdown
		PUBLIC	TCP_Close,TCP_Send,TCP_Recv,TCP_Accept
		PUBLIC	TCP_State,TCP_DownState,TCP_GetAddr,TCP_Peek
		EXTRN	_tcp_activeopen:Near,_tcp_passiveopen:Near,_tcp_shutdown:Near
		EXTRN	_tcp_close:Near,_tcp_send:Near,_tcp_recv:Near,_tcp_accept:Near
		EXTRN	_tcp_state:Near,_tcp_downstate:Near,_tcp_getaddr:Near,_tcp_peek:Near



;
;@́FES:DI=tcpprm
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char tcp_activeopen(TCPPRM far *tcpprm);
TCP_ActiveOpen	PROC

	PUSH	ES
	PUSH	DI
	CALL	_tcp_activeopen
	ADD	SP,4
	RET

TCP_ActiveOpen	ENDP


;
;@́FES:DI=notice
;	 DX=thisport
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char tcp_passiveopen(WORD thisport, void (huge *notice)());
TCP_PassiveOpen	PROC

	PUSH	ES
	PUSH	DI
	PUSH	DX
	CALL	_tcp_passiveopen
	ADD	SP,6
	RET

TCP_PassiveOpen	ENDP


;
;@́FAL=handle
;	 ES:DI=tcpprm
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char tcp_accept(char handle, TCPPRM far *tcpprm);
TCP_Accept	PROC

	PUSH	ES
	PUSH	DI
	MOV	AH,0
	PUSH	AX
	CALL	_tcp_accept
	ADD	SP,6
	RET

TCP_Accept	ENDP


;
;@́FAL=handle
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char tcp_shutdown(BYTE handle);
TCP_Shutdown	PROC

	MOV	AH,0
	PUSH	AX
	CALL	_tcp_shutdown
	ADD	SP,2
	RET

TCP_Shutdown	ENDP


;
;@́FAL=handle
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char tcp_close(BYTE handle);
TCP_Close	PROC

	MOV	AH,0
	PUSH	AX
	CALL	_tcp_close
	ADD	SP,2
	RET

TCP_Close	ENDP


;
;@́FAL=handle
;	 ES:DI=buf
;	 CX=len
;	 DX=flag
;	 DS
;@óFAX
;@jFAX,BX,CX,DX,ES
;	uint tcp_send(BYTE handle, BYTE far *buf, uint len, uint flag);
TCP_Send	PROC

	PUSH	DX
	PUSH	CX
	PUSH	ES
	PUSH	DI
	MOV	AH,0
	PUSH	AX
	CALL	_tcp_send
	ADD	SP,10
	RET

TCP_Send	ENDP


;
;@́FAL=handle
;	 ES:DI=buf
;	 CX=len
;	 DS
;@óFAX
;@jFAX,BX,CX,DX,ES
;	uint tcp_recv(BYTE handle, BYTE far *buf, uint len);
TCP_Recv	PROC

	PUSH	CX
	PUSH	ES
	PUSH	DI
	MOV	AH,0
	PUSH	AX
	CALL	_tcp_recv
	ADD	SP,8
	RET

TCP_Recv	ENDP


;
;@́FAL=handle
;	 ES:DI=buf
;	 CX=len
;	 DS
;@óFAX
;@jFAX,BX,CX,DX,ES
;	uint tcp_peek(BYTE handle, BYTE far *buf, uint len);
TCP_Peek	PROC

	PUSH	CX
	PUSH	ES
	PUSH	DI
	MOV	AH,0
	PUSH	AX
	CALL	_tcp_peek
	ADD	SP,8
	RET

TCP_Peek	ENDP


;
;@́FAL=handle
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char tcp_state(BYTE handle);
TCP_State	PROC

	MOV	AH,0
	PUSH	AX
	CALL	_tcp_state
	ADD	SP,2
	RET

TCP_State	ENDP


;
;@́FAL=handle
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char tcp_downstate(BYTE handle);
TCP_DownState	PROC

	MOV	AH,0
	PUSH	AX
	CALL	_tcp_downstate
	ADD	SP,2
	RET

TCP_DownState	ENDP


;
;@́FAL=handle
;	 ES:DI=addr
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char tcp_getaddr(BYTE handle, TCPADDR far *addr /*[2]*/);
TCP_GetAddr	PROC

	PUSH	ES
	PUSH	DI
	MOV	AH,0
	PUSH	AX
	CALL	_tcp_getaddr
	ADD	SP,6
	RET

TCP_GetAddr	ENDP

;1998/ 9/17
;2001/ 1/23 TCP_Peek

		end
