;
;	^C}[
;	for PC-98x1 / PC-88VA
;
;	$Header: timer.asv  1.1  99/07/24 15:54:44  Exp $
;


		OPTION OLDSTRUCTS

		INCLUDE	STDDEFS.INC
		INCLUDE	TIMERDEV.INC
		INCLUDE	CONFIG.INC

		INCLUDE	IFMAN.INC

		.186
		.MODEL	SMALL

IFNDEF STACKLEN
STACKLEN	EQU 1024
ENDIF

;DISPCOUNT	EQU 1	;^C}[JEgAbvlq\






HANDLES		EQU 8			;^C}[nh̐

					;e^C}[nh̏
TS_Counting	EQU BIT1		;JEg_Eł
TS_Used		EQU BIT0		;gpł


TimerType	STRUC
CallAddress	DW ?
Frequency	DW ?	;(10msecP)
Counter		DW ?
State		DW ?
TimerType	ENDS



		.CODE

		PUBLIC	TIMER_Init,TIMER_Set,TIMER_Remove ;,TIMER_Stop
		PUBLIC	TIMER_Release,TIMER_ReadyToRelease,TIMER_Up
		PUBLIC	TIMER_Clock,TIMER_Tick,TIMER_MSecClock
		PUBLIC	_timer_init,_timer_up ;,_timer_stop
		PUBLIC	_timer_clock,_timer_tick,_timer_msecclock
		;EXTRN	INTMAN_State:WORD
		;EXTRN	TCU_Init:NEAR,TCU_Release:NEAR
		;EXTRN	PPP_TimerSignal:NEAR
		EXTRN	TEEN_SelectUMB:NEAR, TEEN_RelUMB:NEAR


;^C}[(풓P񂾂Ăяo)
;@́FDS
;@jFAX,BX,CX,DX,ES

_timer_init	LABEL	PROC
TIMER_Init	PROC

		MOV	CS:DataSeg,DS

		;e[ȕ
		MOV	BX,OFFSET TimerTable
		_REPEAT HANDLES
			MOV	[BX].State,0
			ADD	BX,TYPE TimerType
		_LOOP

		;Clock 
		;CMP	Machine,0
		TEST	OSType,1
		_IF Z
			;PC-EngineȊO
			MOV	AH,2Ch
			INT	21h		;CH:H,CL:M,DH:S
		_ELSE
			;PC-Engine
			MOV	AH,02h
			INT	8Ch		;CH:H,CL:M,DH:S
		_ENDIF

		MOV	BL,DH
		MOV	AL,CH
		MOV	AH,0
		IMUL	AX,60			;H*60
		ADD	AL,CL
		ADC	AH,0			;H*60+M
		MOV	CX,60
		MUL	CX			;(H*60+M)*60
		ADD	AL,BL
		ADC	AH,0
		ADC	DX,0			;DX.AX=(H*60+M)*60+S

						;DX.AX*1000
		MOV	BX,DX
		MOV	CX,1000
		MUL	CX
		IMUL	BX,1000
		ADD	DX,BX

		MOV	WORD PTR Clock[0],AX
		MOV	WORD PTR Clock[2],DX

		;^C}[N
		MOV	CS:TIMER_UpEntryPoint,0C3h	;RET
							;TIMER_Up֎~
		;CALL	TimerReset
		;CALL	TCU_Init
		CALL	word ptr TimerDev_FunctionTable.TimerDev_Init

		;^C}[̊Ԋu擾
		CALL	word ptr TimerDev_FunctionTable.TimerDev_Interval
						;AX=Ԋu(msec)
		MOV	UnitTime,AX

		;FastTimer
		MOV	BX,AX			;BX=UnitTime
		CLR	DX
		MOV	AX,DesiredFastUnitTime
		DIV	BX
		OR	AX,AX
		@IF Z,	<MOV AX,1>
		MOV	FastUnitTime_Per_UnitTime,AX
		MOV	FastTimer,AX
		MUL	BX
		MOV	FastUnitTime,AX		;FastTimer̎(msec)

		;SlowTimer
		MOV	BX,AX			;BX=FastUnitTime
		CLR	DX
		MOV	AX,DesiredSlowUnitTime
		DIV	BX
		MOV	SlowUnitTime_Per_FastUnitTime,AX
		MOV	SlowTimer,AX

		MUL	BX
		MOV	SlowUnitTime,AX		;SlowTimer̎(msec)

		MOV	BX,10
		;CLR	DX
		DIV	BX
		MOV	SlowUnitTime_10msec,AX


		MOV	CS:TIMER_UpEntryPoint,090h	;NOP
							;TIMER_Up싖

		RET

TIMER_Init	ENDP


;^C}[@\~
TIMER_Release	PROC

		;CALL	TCU_Release
		CALL	word ptr TimerDev_FunctionTable.TimerDev_Release
		RET

TIMER_Release	ENDP


;^C}[@\ł邩
;@óFAX=1..ł 0..łȂ
TIMER_ReadyToRelease	PROC
		CALL	word ptr TimerDev_FunctionTable.TimerDev_ReadyToRelease
		RET
TIMER_ReadyToRelease	ENDP


;^C}[荞
;@́FDS=f[^ZOg
;@ӁFē͋NȂ͂
;@@@@AX,DXȊÕWX^͂ŕۑ(AX,DX͔j\)
;	 CLIԂŌĂяoACLIԂŏI

_timer_up	LABEL	PROC
TIMER_Up	LABEL	PROC
TimerUp		PROC

TIMER_UpEntryPoint	LABEL	BYTE
	NOP

	MOV	DX,1
;	XCHG	CS:INTMAN_State,DX	;DX=INTMAN_State ̈ȑO̒l


	;MOV	DS,CS:DataSeg

	STI				;肠邩


	;v
	MOV	AX,UnitTime
	ADD	WORD PTR Clock,AX
	ADC	WORD PTR Clock[2],0

	;XLbv邩H
	CMP	Timer_Skip,0
	JNZ	@f
;	JNZ	#Skip


	;-------- ZŌĂяo[`
	DEC	FastTimer
	_IF Z
	    PUSHA
	    ;PUSH	DS
	    PUSH	ES

	    MOV	AX,FastUnitTime_Per_UnitTime
	    MOV	FastTimer,AX

IFDEF DISPCOUNT
		DEC	TestCount
		_IF Z
			EXTN	INDICATE

			MOV	TestCount,10
			INC	TestInd
			MOV	DL,TestInd
			MOV	DH,60
			CALL	INDICATE
		_ENDIF
ENDIF



	    MOV	DX,SS
	    MOV	AX,SP

	    CLI
	     MOV	SS,CS:DataSeg
	     MOV	SP,OFFSET DGROUP:EndStack
	    STI

	    PUSH	AX
	    PUSH	DX

	    CALL	TEEN_SelectUMB
	    PUSH	BX

	    CALL	IFMAN_TimerSignal
				;݋ԂŌĂ

				;IFMAN_TimerSignalĂяoԊu
				;100msec -> 64Kbps640byteM
				;           10Mbps100KbyteM

	    POP		BX
	    CALL	TEEN_RelUMB

	    POP	DX
	    POP	AX

	    CLI
	     MOV	SS,DX
	     MOV	SP,AX
	    STI



	    ;------- ŌĂяo[`
	    DEC	SlowTimer
	    _IF Z
	    	MOV	AX,SlowUnitTime_Per_FastUnitTime
	    	MOV	SlowTimer,AX


		MOV	SI,OFFSET TimerTable
		_REPEAT HANDLES
			TEST	[SI].State,TS_Counting
			_IFN Z
				;JEg_E
				MOV	AX,SlowUnitTime_10msec
				SUB	[SI].Counter,AX
				_IF BE
					;^CAEg
					MOV	AX,[SI].Frequency
					MOV	[SI].Counter,AX
					;MOV	AX,HANDLES
					;SUB	AX,CX
					PUSH	CX
					PUSH	SI
					NEG	CX
					ADD	CX,HANDLES

					 MOV	DX,SS
					 MOV	AX,SP

					CLI
					 MOV	SS,CS:DataSeg
					 MOV	SP,OFFSET DGROUP:EndStack
					STI

					 PUSH	AX
					 PUSH	DX

					CALL	TEEN_SelectUMB
					PUSH	BX

					;STI
						;Ŋ荞܂ănhCX
						;폜邱Ƃ댯

						;CX=nh
						;DS=DataSegment
					PUSH	CX	;C֐p
					CALL	[SI].CallAddress
					ADD	SP,2
						;AX,BX,CX,DX,SI,DI,BP,ES
						;j󂳂
					;CLI

					POP	BX
					CALL	TEEN_RelUMB

					 POP	DX
					 POP	AX
					CLI
					 MOV	SS,DX
					 MOV	SP,AX
					STI

					POP	SI
					POP	CX
				_ENDIF
			_ENDIF
			ADD	SI,TYPE TimerType
		_LOOP

		CLI

		;RSM^CAEgp
		MOV	AX,Timer_RSSend
		SUB	AX,SlowUnitTime_10msec
		_IF BE
			CLR	AX
		_ENDIF
		MOV	Timer_RSSend,AX

	    _ENDIF

	    POP	ES
	    ;POP DS
	    POPA

	_ENDIF

@@:
;#Skip:

	CLI

;	MOV	CS:INTMAN_State,DX

	RET

TimerUp		ENDP


IF 0

TimerReset	PROC

		PUSHA
		PUSH	ES

		MOV	CX,UnitTime
		MOV	BX,OFFSET TimerUp
		MOVSEG	ES,CS
		MOV	AH,02h
		INT	1Ch

		POP	ES
		POPA
		RET

TimerReset	ENDP

ENDIF

;^C}[ݒ
;@́FCS:BX=^CAEg̊荞ݏGg(NEAR PROC)
;@@@@CX=荞݊Ԋu(10msecP)
;@@@@DS
;@óFCY=0
;	 AL=nh(!=-1)
;	 CY=1 󂫂
;	 AL=-1
;@jFAX,DX
;@ӁF荞݋Ԃۑ

TIMER_Set	PROC

		PUSH	SI

		PUSHF
		CLI

		;󂫒T
		MOV	DX,CX
		MOV	SI,OFFSET TimerTable
		_REPEAT HANDLES
			TEST	[SI].State,TS_Used
			_BREAK Z
			ADD	SI,TYPE TimerType
		_LOOP
		JCXZ	@f
;		JCXZ	#NoHandle

		MOV	AL,HANDLES
		SUB	AL,CL

		OR	[SI].State,(TS_Used OR TS_Counting)
		MOV	[SI].CallAddress,BX
		MOV	[SI].Frequency,DX
		MOV	[SI].Counter,DX

		POPF

		CLC
		POP	SI
		RET

@@:
;#NoHandle:
		;󂫂
		POPF

		STC
		MOV	AL,-1
		POP	SI
		RET

TIMER_Set	ENDP


;^C}[폜
;@́FAL=nh
;@@@@DS
;@jFBX
;@ӁF荞݋Ԃۑ

TIMER_Remove	PROC

		CMP	AL,HANDLES
		JAE	@f
;		JAE	#Exit

		PUSHF
		CLI

		MOV	BL,AL
		MOV	BH,0
		IMUL	BX,TYPE TimerType
		RES	TimerTable[BX].State,<(TS_Used OR TS_Counting)>

		POPF
@@:
;#Exit:
		RET

TIMER_Remove	ENDP


;Clock̒l10msecPʂŕԂ
;@óFDX.AX=ݎ(10msec)
;@jFBX,CX
_timer_clock	LABEL	PROC
TIMER_Clock	PROC

		;Clock/10 ߂

		MOV	BX,10
		CLR	DX
		MOV	AX,WORD PTR Clock[2]
		DIV	BX			; 0000.Clock[2] / 10

		MOV	CX,AX			;Clock/10̏16rbg

		MOV	AX,WORD PTR Clock[0]
		DIV	BX			; O񂠂܂.Clock[0]/10

		MOV	DX,CX
						;DX.AX=Clock/10
		RET

TIMER_Clock	ENDP


;^C}[̐x(UnitTime)10msecbPʂŕԂ
;@jFBX,DX
_timer_tick	LABEL	PROC
TIMER_Tick	PROC

		MOV	AX,UnitTime
		CLR	DX
		MOV	BX,10
		DIV	BX
		RET

TIMER_Tick	ENDP

;Clock̒lmsecPʂŕԂ
;@óFDX.AX=ݎ(msec)
;@óF
;@jF
_timer_msecclock	LABEL	PROC
TIMER_MSecClock	PROC
		MOV	AX,WORD PTR Clock[0]
		MOV	DX,WORD PTR Clock[2]
		RET
TIMER_MSecClock	ENDP



DataSeg		DW ?
Stopped		DB ?

;-----------------------
;	f[^
;-----------------------
		.DATA

		PUBLIC	Timer_Skip
		;EXTRN	Machine:BYTE
		EXTRN	OSType:BYTE
		EXTRN	TimerDev_FunctionTable:BYTE



		;^C}[[`̎sXLbvƂ͔0ɂB
		;RSMCD.ASM gp
Timer_Skip	DW 0


IFDEF DISPCOUNT

		;^C}[JEgAbvlq\
TestCount	DB 10
TestInd		DB ' '

ENDIF

;--------[CONFIG]

		PUBLIC	TIMER_Section,TIMER_DesiredFastUnitTime

TIMER_Section	SectionType <SectName,0,RegInfo>
SectName	DB "TIMER",0
RegInfo		RegisterInfoType <0,0,  2,TIMER_WReg, 0,0, 0,0, 0>

TIMER_WReg	LABEL	WORD

TIMER_DesiredFastUnitTime	LABEL	WORD
DesiredFastUnitTime	DW 100		;ZŌĂяo[`
					;Ăяo(msecP,
					;UnitTime̔{ǂ
DesiredSlowUnitTime	DW 500		;(x)ŌĂяo[`
					;Ăяo(msecP,
					;FastUnitTime̔{ǂ)


;--------[END OF CONFIG]


		.DATA?

		PUBLIC	Timer_RSSend
		PUBLIC	TIMER_DATA
		EXTRN	MachType:BYTE,OSType:BYTE

TIMER_DATA	LABEL	WORD

UnitTime	DW ?			;n[hEFÅ݂Ԋu(msecP)

FastUnitTime	DW ?			;ZŌĂяo[`
					;Ăяo(msecP,UnitTime̔{
SlowUnitTime	DW ?			;(x)ŌĂяo[`
					;Ăяo(msecP,
					;FastUnitTime̔{)
SlowUnitTime_10msec	DW ?		;(10msecP)

FastUnitTime_Per_UnitTime	DW ?
SlowUnitTime_Per_FastUnitTime	DW ?


FastTimer	DW ?				;ZŌĂяo[`
						;Ăяo^C~O߂
SlowTimer	DW ?				;ŌĂяo[`
						;Ăяo^C~O߂

Clock		DD ?				;1msecPʂ̎v

Timer_RSSend	DW ?				;RSM^CAEgp(10msec)

TimerTable	TimerType HANDLES DUP (<>)


_STACK		SEGMENT	PUBLIC	'STACK'
		DB	STACKLEN DUP (?)
EndStack	LABEL	BYTE
_STACK		ENDS


;1997/ 9/ 3 
;1997/ 9/15 
;1997/10/13 X^bNp
;1997/10/20 
;1997/12/ 2 
;1998/ 2/28 RSM^CAEgp^C}
;1998/ 3/20 Timer_Clock
;1999/ 4/17 nh𑝂₵B荞݊Ԋu
;1999/ 4/18 TCU.ASM p
;1999/ 5/11 uŌĂяo[`v
;1999/ 5/12 uZŌĂяo[`v,PPP_TimerSignal 𒼐ڌĂяo
;1999/ 7/24 Timer_Skip
;2000/ 1/ 3 TIMER_Up  _timer_up ̕ʖǉ
;2000/ 1/ 5 TimerDev_FunctionTablegp. UnitTimeς.
;	    Timer_Clock(10msec) -> Clock (1msec). 
;	    ֐ TIMER_Clock,TIMER_Tickǉ
;2000/10/ 3 PPP_TimerSignal ̑ IFMAN_TimerSignal ĂяoB
;2001/ 1/13 Clock̏l10msecPʂŋ߂Ă̂C
;2001/ 1/19 INTMAN_State gp~
;2001/ 1/23 TIMER_MSecClock
;2002/ 9/15 UMB(PC-88VA)Ή

COMMENT *

oO

  D  TIMER_Clock œl A(10msec) 񂾂ƂB
  TIMER_Set  A ̌Ɋ݂悤ɐݒ肷ƁAۂɊ݂̂
  ĎAɌɂȂB
  (AUnitTime  1msec ̃P^ 0 ŖꍇBTIMER_Clock ł 1msec
  P^JEgĂ̂ɑ΂ATIMER_Set񋟂^C} 1msec ̃P^
  B)

*

		end
