/*
	f[^Ǘ
	for i80x86

	$Header$
*/

#include <dos.h>

#include "log.h"
#include "tmem.h"

#define NULL 0


struct dmcb {				/* f[^Rg[ubN */
	WORD paras;			/* ubN(DMCB)̃TCY */
	WORD nextdmcb;			/* ̂clbãpOt */
	WORD predmcb;			/* ÔclbãpOt */
	WORD owner;			/* 0..gp ȊO..gp */
};

static WORD dmseg;			/* f[^擪pOt */
static WORD dmparas;			/* f[^pOtTCY */
static uint tmem_used;			/* f[^gp(pOt)
       					   DMCB ܂ */
       uint tmem_usedmax;		/* f[^gpʍő(pOt)
       					   DMCB ܂ */
#if 0
       uint tmem_shortagemax;		/* sƂꍇ
					   ɕsTCY̍ő(pOt) */
#endif
static TMEMFLAG tmem_flag;


/*
@󂫃ubŇigpj
@@@́Fuint rparas  Kvȋ󂫃ubÑTCY
	    uint *max
@@@óFvoid far *   󂫃ubN̂clbaւ̃|C^
	    uint max	 LNULL̂ƂA󂫂̍ő̃pOtTCY
*/
static struct dmcb far *_find_freeblock(uint rparas, uint *max)
{
	struct dmcb far *pt;

	*max=0;
	pt=MK_FP(dmseg,0);
	while (pt!=NULL) {
		if (pt->owner==0) {
			/* 󂫃ubN */
			if (pt->paras > *max) *max=pt->paras;
			if (*max >= rparas) break;
		}
		pt=MK_FP(pt->nextdmcb,0);
	}
	return pt;
}

#if 0
/*
@gp̃pOtTCYvigpj
@@@óFuint         pOtTCY(DMCB)
*/
static uint used_size(void)
{
	struct dmcb far *pt;
	uint size=0;

	pt=MK_FP(dmseg,0);
	while (pt!=NULL) {
		if (pt->owner!=0) {
			/* gpubN */
			size+=pt->paras;
		}
		pt=MK_FP(pt->nextdmcb,0);
	}
	return size;
}
#endif

/*
@uf[^Ǘv̊Ǘɒu̐ݒ
@@@́FWORD seg		̐擪pOt
@@@@@@uint paras		̃pOtTCY
*/
void tmem_init(WORD seg, uint paras)
{
	struct dmcb far *pt;

	tmem_usedmax=tmem_used=0;
	*((WORD *)&tmem_flag)=0;
	dmseg=seg;
	dmparas=paras;

	pt=MK_FP(dmseg,0);
	pt->paras=paras-1;
	pt->owner=0;
	pt->predmcb=NULL;
	pt->nextdmcb=NULL;
}


/*
@ubN擾̃Tu[`igpj
@@@́FWORD cdmcb		ۯDMCBpOt
@@@@@@uint rparas		擾pOtTCY
@@@⑫Fcdmcb Ŏw肳ꂽubNKvȕ𕪊B
*/
static void _tmem_alloc(WORD cdmcb, uint rparas)
{
	struct dmcb far *pt, far *pt2, far *pt3;
	WORD cdmcb2,cdmcb3;

	pt=MK_FP(cdmcb,0);

	if ((pt->paras) <= (rparas+1)) {
		/* ̕KvȂ */
		pt->owner=1;
	}
	else {
		cdmcb3=pt->nextdmcb;
		pt3=MK_FP(cdmcb3,0);
		cdmcb2=cdmcb+rparas+1;
		pt2=MK_FP(cdmcb2,0);

		pt2->paras=pt->paras-rparas-1;
		pt2->owner=0;
		pt2->predmcb=cdmcb;
		pt2->nextdmcb=cdmcb3;

		pt->paras=rparas;
		pt->owner=1;
		pt->nextdmcb=cdmcb2;

		if (cdmcb3!=NULL) {
			pt3->predmcb=cdmcb2;
		}
	}
}


/*
@ubN擾
@@@́Fuint paras		擾pOtTCY
@@@óFvoid far *		FubNAhX(ItZbg0)
				sF0
*/
void far *tmem_alloc(uint rparas)
{
	struct dmcb far *pt;
	uint req;
/*
	log_printf("TMEM: 擾v %u",rparas);
*/
	disable();

	pt=(struct dmcb far *)_find_freeblock(rparas,&req);
	if (pt!=NULL) {
		_tmem_alloc(FP_SEG(pt),rparas);
		tmem_used += pt->paras+1;
		pt=MK_FP(FP_SEG(pt)+1,0);
		if (tmem_used > tmem_usedmax) tmem_usedmax=tmem_used;
	}
	else {
		enable();
		log_printf("TMEM: s v:%u \:%u",rparas,req);
		rparas -= req;
		tmem_flag.notenough=1;
		tmem_disp();
	}

	enable();
/*
	log_printf("TMEM: 擾 %Fp",pt);
*/
	return pt;
}


/*
@ubNJ̃Tu[`igpj
@@@⑫Fw肳ꂽubNJƂƂɁÃubN󂫂Ȃ΂
@@@@@@ƌ
*/
static void _tmem_free(WORD cdmcb)
{
	struct dmcb far *pt, far *pt2, far *pt3;

	pt=MK_FP(cdmcb,0);
	pt->owner=0;
	if (pt->nextdmcb==NULL) {return;}

	pt2=MK_FP(pt->nextdmcb,0);
	if (pt2->owner!=0) {return;}

	pt->nextdmcb=pt2->nextdmcb;
	pt->paras+=pt2->paras + 1;

	if (pt2->nextdmcb==NULL) {return;}

	pt3=MK_FP(pt2->nextdmcb,0);
	pt3->predmcb=cdmcb;
}


/*
@ubN̊J
@@@́Fvoid far *pt	ubNւ̃|C^
@@@óFint			@F 0
				G[F-1
*/
int tmem_free(void far *pt_)
{
	struct dmcb far *pt;
	WORD cdmcb,ndmcb;

	/*if (FP_OFF(pt_)!=0) return -1;*/
/*
	log_printf("TMEM: v %Fp",pt_);
*/
	cdmcb=FP_SEG(pt_)-1;
	pt=(struct dmcb far *)MK_FP(cdmcb,0);

	disable();

	/* pt,cdmcb ǂ */
	ndmcb=pt->nextdmcb;
	if (ndmcb!=0) {
		if ( ((struct dmcb far *)(MK_FP(ndmcb,0)))->predmcb != cdmcb) {
			goto free_err;
		}
	}
	ndmcb=pt->predmcb;
	if (ndmcb!=0) {
		if ( ((struct dmcb far *)(MK_FP(ndmcb,0)))->nextdmcb !=cdmcb) {
			goto free_err;
		}
	}
	else {
		if (cdmcb!=dmseg) goto free_err;
	}

	/* J */
	if (pt->owner!=0) {
		tmem_used -= pt->paras+1;
		_tmem_free(cdmcb);
		if (ndmcb!=NULL) {
			pt=MK_FP(ndmcb,0);
			if (pt->owner==0) _tmem_free(ndmcb);
		}
	}
	else {
		log_printf("TMEM: sȉ:ς");
	}
	
	enable();
	return 0;

free_err:	;
	enable();
	log_printf("TMEM: sȉ %Fx",pt_);
	return -1;
}



/*
@f[^Rg[ubNiclbaj`FbN
@@@́FȂ
@@@óFF 0  ُF -1
*/
int tmem_check(void)
{
	struct dmcb far *pt;
	WORD cdmcb,pdmcb;
	uint pparas;

	cdmcb=dmseg;
	pdmcb=NULL;
	pparas=0;

	for(;;) {
		pt=MK_FP(cdmcb,0);
		if (pt->predmcb!=pdmcb) {break;}
		if (pdmcb!=0 && cdmcb-pdmcb-1!=pparas) {break;}
		pparas=pt->paras;
		pdmcb=cdmcb;
		cdmcb=pt->nextdmcb;
		if (cdmcb==NULL) {return 0;}
	}
	return -1;
}


/*
@ubN̕\
@@@́FȂ
@@@óFȂ
*/
void tmem_disp(void)
{
	struct dmcb far *pt;
	char cmemo[13];
	int i;
	WORD cdmcb;

	if (tmem_check()) {
		log_put("TMEM: ްغ۰ۯُ");
		/*return;*/
	}

	log_put("TMEM: ADD   SIZE   USE");

	cdmcb=dmseg;
	pt=MK_FP(cdmcb,0);

	for(;;) {
		log_printf("TMEM: %4X (%4Xh) %2X",cdmcb+1,pt->paras,pt->owner);

		cdmcb=pt->nextdmcb;
		if (cdmcb==NULL) {break;}
		if (cdmcb>=dmseg+dmparas || cdmcb<dmseg) {break;}
		pt=MK_FP(cdmcb,0);
	};
	log_printf("TMEM: őgp %4Xh pOt",tmem_usedmax);
}

/*
@̎擾
@@@́FTMEMINFO far *info	i[̈
@@@@@@uint size		i[̈TCY
@@@óFȂ
*/
void tmem_info(TMEMINFO far *info, uint size)
{
	if (size>=sizeof(TMEMINFO)) {
		info->seg=dmseg;
		info->paras=dmparas;
		info->usedmax=tmem_usedmax;
		info->flag=tmem_flag;
	}
}



/*
@eXgpC
*/
#if defined(DEBUG)
/*
	for PC-88VA
*/

#include <alloc.h>
#include <stdlib.h>
#include <kybdva.h>			/* s88va250 */

uint a16toi(char *str)
{
	uint a=0;
	char c;

	while((c=*str++)!='\0') {
		c=toupper(c);
		if (c<'0') break;
		else if (c<='9') c-='0';
		else if (c<'A') break;
		else if (c<='F') c-=('A'-10);
		else break;
		a=a*16+c;
	}
	return a;
}


void main(void)
{
	void far *mem,far *blk1,far *blk2;
	WORD dmseg;
	uint para;
	uchar rattr;
	int a,x,y;
	char buff[80]="";


#define MEMSIZE 60000L
	mem=farmalloc(MEMSIZE);
	dmseg=FP_SEG(mem)+1;
	para=MEMSIZE/16-1;

	log_init();
	tmem_init(dmseg,(uint)(MEMSIZE/16-1));
	printf("%Fp  %x %x \n",mem,dmseg,para);

	while (1) {
		void far *pt;

		tmem_disp();

		printf("擾(0)̊J(1)\n");
		get_cursor_pos(&x, &y);
		inp_str(x,y,buff,79);
		printf("\n");

		switch (buff[0]) {
		case '0':
			printf("擾obt@TCY͂(hex)\n");
			get_cursor_pos(&x, &y);
			inp_str(x,y,buff,79);
			printf("\n");
			a=a16toi(buff);

			pt=tmem_alloc(a);
			if (pt==0) {printf("ƂȂ\n");}
			printf("address = %Fp\n",pt);
			break;

		case '1':
			printf("Jobt@̃ZOg(hex)\n");
			get_cursor_pos(&x, &y);
			inp_str(x,y,buff,79);
			printf("\n");
			a=a16toi(buff);

			a=tmem_free(MK_FP(a,0));
			if (a) {printf("Jł\n");}
			break;

		default: return;
		}
	}
}


#endif


/*
1998/ 3/ 8	?
1999/ 8/18 	tmem_alloc: tmem_useďvZ
		tmem_free: ɉς݃ꍇtmem_usedύX
		logo͂Q_ǉ
2000/ 3/17      logo͒ǉ, tmem_useďvZC
2000/ 9/ 3	logo͈ꕔ폜
2000/ 9/23	logo͈ꕔ폜
2002/ 9/ 9 	ϐtmem_shortagemaxǉBsʂL^B
		tmem_info ǉ
		tmem_disp őgpʂ16i\L
2002/10/13 	tmem_shortagemax폜BuƂǂꂾΑ邩v̏ɂ
		ȂȂ߁Btmem_flagǉB
*/
