;
;	UDPAPI.C - ASM C^tF[X
;	for i8086,Turbo-C
;
;	$Header$
;

		OPTION OLDSTRUCTS
		INCLUDE	STDDEFS.INC

		.186
		.MODEL	SMALL


			;sendto,recvfrom p[^e[u
BufAddrTable	STRUC
BAT_Buf		DD ?	;obt@ւ̃|C^
BAT_Len		DW ?	;obt@̃TCY
BAT_Port	DW ?	;|[gԍ
BAT_Addr	DD ?	;IPAhX\̂ւ̃|C^
BufAddrTable	ENDS



		.CODE

		PUBLIC	UDP_Open
		PUBLIC	UDP_Close,UDP_Send,UDP_Recv
		PUBLIC	UDP_State
		PUBLIC	UDP_SendTo,UDP_RecvFrom
		PUBLIC	UDP_GetMyAddr,UDP_GetPeerAddr
		EXTRN	_udp_open:Near
		EXTRN	_udp_close:Near,_udp_send:Near,_udp_recv:Near
		EXTRN	_udp_state:Near
		EXTRN	_udp_sendto:Near,_udp_recvfrom:Near
		EXTRN	_udp_getmyaddr:Near,_udp_getpeeraddr:Near

;
;@́FES:DI=udpprm
;	 AL=0
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char udp_open(const UDPPRM far *udpprm);
UDP_Open	PROC

	OR	AL,AL
	JNZ	@f
;	JNZ	#Err

	PUSH	ES
	PUSH	DI
	CALL	_udp_open
	ADD	SP,4
	RET

@@:
;#Err:
	MOV	AL,80h+01h	;NoFunc
	RET

UDP_Open	ENDP




;
;@́FAL=handle
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char udp_close(BYTE handle);
UDP_Close	PROC

	MOV	AH,0
	PUSH	AX
	CALL	_udp_close
	ADD	SP,2
	RET

UDP_Close	ENDP


;
;@́FAL=handle
;	 ES:DI=buf
;	 CX=len
;	 DS
;@óFDX.AX
;@jFBX,CX,ES
;	long udp_send(BYTE handle, const BYTE far *buf, uint len);
UDP_Send	PROC

	PUSH	CX
	PUSH	ES
	PUSH	DI
	MOV	AH,0
	PUSH	AX
	CALL	_udp_send
	ADD	SP,8
	RET

UDP_Send	ENDP


;
;@́FAL=handle
;	 ES:DI=buf
;	 CX=len
;	 DS
;@óFAX
;@jFAX,BX,CX,DX,ES
;	long udp_recv(BYTE handle, BYTE far *buf, uint len);
UDP_Recv	PROC

	PUSH	CX
	PUSH	ES
	PUSH	DI
	MOV	AH,0
	PUSH	AX
	CALL	_udp_recv
	ADD	SP,8
	RET

UDP_Recv	ENDP


;ĐtM
;@́FAL=handle
;	 ES:DI=p[^e[u
;	 DS
;@óFDX.AX
;@jFBX,CX,ES
;	long udp_sendto(BYTE handle, const BYTE far *buf, uint len, const void far *toaddr, WORD toport)

UDP_SendTo	PROC

	PUSH	ES:[DI].BAT_Port
	PUSH	WORD PTR ES:[DI].BAT_Addr[2]
	PUSH	WORD PTR ES:[DI].BAT_Addr[0]
	PUSH	ES:[DI].BAT_Len
	PUSH	WORD PTR ES:[DI].BAT_Buf[2]
	PUSH	WORD PTR ES:[DI].BAT_Buf[0]
	MOV	AH,0
	PUSH	AX
	CALL	_udp_sendto
	ADD	SP,7*2
	RET

UDP_SendTo	ENDP


;MҏtM
;@́FAL=handle
;	 ES:DI=p[^e[u
;	 DS
;@óFDX.AX
;@jFBX,CX,ES
;	long udp_recvfrom(BYTE handle, BYTE far *buf, uint len, 
;				IPADDR far *fromaddr, WORD far *fromport)
UDP_RecvFrom	PROC

	PUSH	ES
	LEA	DX,[DI].BAT_Port
	PUSH	DX

	PUSH	WORD PTR ES:[DI].BAT_Addr[2]
	PUSH	WORD PTR ES:[DI].BAT_Addr[0]

	PUSH	ES:[DI].BAT_Len

	PUSH	WORD PTR ES:[DI].BAT_Buf[2]
	PUSH	WORD PTR ES:[DI].BAT_Buf[0]

	MOV	AH,0
	PUSH	AX

	CALL	_udp_recvfrom
	ADD	SP,8*2

	RET

UDP_RecvFrom	ENDP



;
;@́FAL=handle
;	 DS
;@óFAL
;@jFAX,BX,CX,DX,ES
;	char udp_state(BYTE handle);
UDP_State	PROC

	MOV	AH,0
	PUSH	AX
	CALL	_udp_state
	ADD	SP,2
	RET

UDP_State	ENDP


;̃AhXƃ|[gԍ𓾂
;@́FAL = handle
;	 ES:DI = addr
;	 DS
;@óFCF=0
;		AX=|[gԍ
;	 CF=1
;		AL=G[ԍ
;		AH=s
;@jFBX,CX,DX,ES
;	char udp_getmyaddr(BYTE handle, IPADDR far *addr, WORD far *port);
UDP_GetMyAddr	PROC

	MOV	BX,OFFSET _udp_getmyaddr

UDPGetAddr::
	PUSH	DX	;X^bNQoCgm *port 
	MOV	DX,SP

	PUSH	SS
	PUSH	DX

	PUSH	ES
	PUSH	DI

	MOV	AH,0
	PUSH	AX
	
	CALL	BX
	ADD	SP,10

	POP	DX	;DX=*port

	OR	AL,AL
	STC
	_IF Z
		;G[Ȃ
		MOV	AX,DX
		CLC
	_ENDIF

	RET

UDP_GetMyAddr	ENDP

;̃AhXƃ|[gԍ𓾂
;@́FAL = handle
;	 ES:DI = addr
;@óFCF=0
;		AX=|[gԍ
;	 CF=1
;		AL=G[ԍ
;		AH=s
;@jFBX,CX,DX,ES
;	char udp_getpeeraddr(BYTE handle, IPADDR far *addr, WORD far *port);
UDP_GetPeerAddr	PROC
	MOV	BX,OFFSET _udp_getpeeraddr
	JMP	UDPGetAddr
UDP_GetPeerAddr	ENDP

		end
